Imports System.Math
Imports System.IO
Module Elasticite_Plane
    'Variables publiques  l'ensemble du module
    Dim title As String = "STRUCTURE : module de calcul Analyse Lineaire 3D"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly
    Dim msgg As String
    Public Sub Analyse_Elasticite_Plane(ByRef structure_OK As Boolean)
        Dim Delta, Xi, Xj, Xk, Yi, Yj, Yk As Double
        Dim R(50, 10), BB(3, 5), DD(3, 3) As Double
        Dim msg As String
        Dim i As Integer
        'Calcul des lments pour la matrice de rigidit
        delta = (xj - xi) * (yk - yi) - (yj - yi) * (xk - xi)
        If Delta <= 0.00000001 Then
            msg = "Surface ngative ou nulle pour l'lment " & CStr(i)
            MsgBox(msg, style, title)
            structure_OK = False : Exit Sub
        End If
        R(i, 1) = (Yj - Yk) / Delta
        R(i, 2) = (Yk - Yi) / Delta
        R(i, 3) = (Yi - Yj) / Delta
        R(i, 4) = (Xk - Xj) / Delta
        R(i, 5) = (Xi - Xk) / Delta
        R(i, 6) = (Xj - Xi) / Delta
        R(i, 7) = Delta / 2
        Select Case Type_probleme
            Case 11 'Dformation plane
                R(i, 8) = Ey(i) * (1 - Poiss(i)) / ((1 + Poiss(i)) * (1 - 2 * Poiss(i)))
                R(i, 9) = R(i, 8) * Poiss(i) / (1 - Poiss(i))
                R(i, 10) = Ey(i) / ((1 + Poiss(i)) * 2)
            Case 12 'Contrainte Plane
                R(i, 7) = R(i, 7) * ep(i)
                R(i, 8) = Ey(i) / (1 - Poiss(i) ^ 2)
                R(i, 9) = R(i, 8) * Poiss(i)
                R(i, 10) = Ey(i) / ((1 + Poiss(i)) * 2)
        End Select
        'Matrice de rigidit de l'lment
        BB(1, 1) = R(i, 1) : BB(3, 2) = R(i, 1)
        BB(1, 3) = R(i, 2) : BB(3, 4) = R(i, 2)
        BB(1, 5) = R(i, 3) : BB(3, 6) = R(i, 3)
        BB(2, 2) = R(i, 4) : BB(3, 1) = R(i, 4)
        BB(2, 4) = R(i, 5) : BB(3, 3) = R(i, 5)
        BB(2, 6) = R(i, 6) : BB(3, 5) = R(i, 6)

        DD(1, 1) = R(i, 8) : DD(2, 2) = R(i, 8)
        DD(1, 2) = R(i, 9) : DD(2, 1) = R(i, 9)
        DD(3, 3) = R(i, 10) 'nnnnnnn

    End Sub
End Module
