﻿Imports System.Math
Imports System.Drawing
Public Class frmResultGraph
    Dim Vue_deformee, Vue_Fy, Vue_Mz As Boolean
    Dim cosa, cosb, sina, sinb, coscosba, cossinba, sincosba, sinsinba, zoom As Double
    Private Sub Form2_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'affichage de  tous les cas de charges
        Dim i, j, total_charge As Integer ', l1(100), l2(100)
        For i = 1 To 4
            total_charge = total_charge + Total_cas_de_charge(i)
        Next
        ChkbComb.Checked = False
        ChkbCas.Checked = True
        'gestion des listbox
        LB2.SelectionMode = SelectionMode.MultiSimple
        RbtnLB2SelMultiSimple.Checked = True
        RbtnLB2SelMultiEtendu.Checked = False
        'Chargement de tous les cas de charge dans la listbox LB2
        LB2.Items.Clear()
        For i = 1 To total_charge
            LB2.Items.Add(i.ToString)
            LB2.SetSelected(i - 1, True) 'sélection de toute la collection
        Next
    End Sub
    Private Sub frmVisu_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        PBox1.Refresh()
    End Sub

    Private Sub PBox1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PBox1.Paint
        'obligation de faire appel à la méthode d'affichage depuis l'évènement Paint pour obtenir la persistance de l'affichage. voir rubrique d'aide VB.NET

        Call Affichage_Structure(e)
    End Sub
    Private Sub Affichage_Structure(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim red As Double
        Dim i, j, j1, k, n, nbr_charge, L_Charge() As Integer
        Dim xx1, yy1, xx2, yy2, xx3, yy3 As Single
        Dim a, Ai(4), b, L, Xmf, Ymf, alpha, d1, d2, Mmax, Tf, Tfmax, Flmax, mf, fl As Double
        Dim g As Graphics = pe.Graphics
        Dim myPen As New Pen(Color.Black, 1)
        Dim myPen1 As New Pen(Color.Red, 1)
        Dim myPen2 As New Pen(Color.Blue, 1)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim x1(Total_noeud), y1(Total_noeud), z1(Total_noeud) As Double

        Call Preparation_affichage(red, x1, y1, z1)
        Dim Mfz(,), Tfy(,), Fle(,) As Double
        If chkbNoe.Checked = True Then Call Affichage_noeud(pe)
        If chkbBarre.Checked = True Then Call Affichage_Element(pe)
        If chkbAppui.Checked = True Then Call Affichage_appui(pe)
        If ChkbOrdonne.Checked = True Then Call Affichage_Ordonne(pe)
        'dessin de la structure
        Select Case Type_probleme
            Case 1, 2
                'dessin du repère global
                xx1 = PBox1.Width - 50 : xx2 = PBox1.Width - 25
                g.DrawLine(myPen, xx1, 50, xx2, 50) 'axe x
                g.DrawString("X", myFont, myBrush, xx2, 55)
                g.DrawLine(myPen, xx1, 50, xx1, 25) 'axe y
                g.DrawString("Y", myFont, myBrush, xx1 - 10, 10)
                'dessin de la structure
                For i = 1 To Total_element
                    Call posxy(x1(Ele(1, i)), y1(Ele(1, i)), 0, xx1, yy1, red)
                    Call posxy(x1(Ele(2, i)), y1(Ele(2, i)), 0, xx2, yy2, red)
                    g.DrawLine(myPen, xx1, yy1, xx2, yy2)
                Next
                Dim item As Object
                i = 0
                nbr_charge = 0
                For Each item In LB2.SelectedItems
                    nbr_charge = nbr_charge + 1
                    ReDim Preserve L_Charge(nbr_charge) 'indique le n° de cas de charge sélectionné ou n° de combinaison
                    L_Charge(nbr_charge) = CInt(CType(item, String))   'l'indice commençant à 0 
                Next
                For i = 1 To nbr_charge
                    Call Result_intermediaire(L_Charge(i), Mfz, Tfy, Mmax, Tfmax, Fle, Flmax) 'L_Charge(i) = n° de cas ou de combinaison
                    For j1 = 1 To Total_element
                        For j = 1 To 2
                            If Flmax < Abs(Depl(i, Ele(1, j1), j)) Then Flmax = Abs(Depl(i, Ele(1, j1), j))
                            If Flmax < Abs(Depl(i, Ele(2, j1), j)) Then Flmax = Abs(Depl(i, Ele(2, j1), j))
                        Next
                    Next
                    For j = 1 To Total_element
                        Call posxy(x1(Ele(1, j)), y1(Ele(1, j)), 0, xx1, yy1, red)
                        Call posxy(x1(Ele(2, j)), y1(Ele(2, j)), 0, xx2, yy2, red)
                        a = X_noe(Ele(2, j)) - X_noe(Ele(1, j))
                        b = Y_noe(Ele(2, j)) - Y_noe(Ele(1, j))
                        L = Sqrt(a ^ 2 + b ^ 2) 'longueur de l'élément
                        d1 = Acos(a / L) : d2 = Asin(b / L)
                        'l'angle alpha doit être compris entre 0 et 2pi ce qui oblige à la gymnastique ci-dessous sinon
                        'l'angle allait être compris entre 0 et pi ou pi/2 et -pi/2 suivant si le calcul était fait en
                        'cosinus ou sinus
                        If a >= 0 And b >= 0 Then  'quadrant 1
                            alpha = d1
                        ElseIf a <= 0 And b >= 0 Then 'quadrant 2
                            alpha = d1
                        ElseIf a <= 0 And b <= 0 Then 'quadrant 3
                            alpha = PI - d2  'd2 est négatif
                        ElseIf a >= 0 And b <= 0 Then 'quadrant 4
                            alpha = 2 * PI + d2
                        End If
                        n = CInt(Fix(L / 0.1))
                        k = 0
                        If ChkbMz.Checked = True Then
                            mf = (Mfz(j, k) / Mmax) * NuD1.Value
                            xx3 = CSng(xx1 - mf * Sin(alpha)) : yy3 = CSng(yy1 + mf * Cos(alpha))
                            Do While k < n
                                k = k + 1
                                mf = (Mfz(j, k) / Mmax) * NuD1.Value '20pixel initial
                                Xmf = CSng(xx1 + (xx2 - xx1) * k / n - mf * Sin(alpha))
                                Ymf = CSng(yy1 + (yy2 - yy1) * k / n + mf * Cos(alpha))
                                g.DrawLine(myPen1, xx3, yy3, CSng(Xmf), CSng(Ymf))
                                xx3 = CSng(Xmf) : yy3 = CSng(Ymf)
                            Loop
                        End If
                        k = 0
                        If ChkbFy.Checked = True Then
                            Tf = (Tfy(j, k) / Tfmax) * NuD1.Value
                            xx3 = CSng(xx1 - Tf * Sin(alpha)) : yy3 = CSng(yy1 + Tf * Cos(alpha))
                            Do While k < n
                                k = k + 1
                                Tf = (Tfy(j, k) / Tfmax) * NuD1.Value '20pixel initial
                                Xmf = CSng(xx1 + (xx2 - xx1) * k / n - Tf * Sin(alpha))
                                Ymf = CSng(yy1 + (yy2 - yy1) * k / n + Tf * Cos(alpha))
                                g.DrawLine(myPen1, xx3, yy3, CSng(Xmf), CSng(Ymf))
                                xx3 = CSng(Xmf) : yy3 = CSng(Ymf)
                            Loop
                        End If
                        If ChkbDeformee.Checked = True Then
                            xx1 = CSng(xx1 + ((Depl(i, Ele(1, j), 1) / Flmax) * NuD1.Value)) : yy1 = CSng(yy1 + ((Depl(i, Ele(1, j), 2) / Flmax) * NuD1.Value))
                            xx2 = CSng(xx2 + ((Depl(i, Ele(2, j), 1) / Flmax) * NuD1.Value)) : yy2 = CSng(yy2 + ((Depl(i, Ele(2, j), 2) / Flmax) * NuD1.Value))
                            fl = (Fle(j, k) / Flmax) * NuD1.Value
                            xx3 = CSng(xx1 - fl * Sin(alpha)) : yy3 = CSng(yy1 + fl * Cos(alpha))
                            Do While k < n
                                k = k + 1
                                fl = (Fle(j, k) / Flmax) * NuD1.Value '20pixel initial
                                Xmf = CSng(xx1 + (xx2 - xx1) * k / n - fl * Sin(alpha))
                                Ymf = CSng(yy1 + (yy2 - yy1) * k / n + fl * Cos(alpha))
                                g.DrawLine(myPen1, xx3, yy3, CSng(Xmf), CSng(Ymf))
                                xx3 = CSng(Xmf) : yy3 = CSng(Ymf)
                            Loop
                        End If
                    Next
                Next


            Case 3, 4
                ''dessin de la structure
                'Select Case Affichage
                '    Case 10
                '        Gauche()
                '    Case 11
                '        Droite()
                '    Case 12
                '        Haut()
                '    Case 13
                '        Bas()
                'End Select
                ''dessin du repère global
                'yy1 = 50 : xx1 = PBox1.Width - 50
                'xx2 = 0 : yy2 = 1 : zz2 = 0
                'Dim xx31, yy31, xx32, yy32, xx33, yy33, red1 As Single
                'red1 = 4
                'xx31 = CSng(red * (yy2 * cosa + xx2 * sina))
                ''If xx31 > 10 Then red1 = xx31 / 10
                'yy31 = CSng(red * (yy2 * cossinba - xx2 * coscosba - zz2 * sinb))
                ''If yy31 / red1 > 10 Then red1 = yy31 / 10
                'xx2 = 1 : yy2 = 0 : zz2 = 0
                'xx32 = CSng(red * (yy2 * cosa + xx2 * sina))
                ''If xx32 / red1 > 10 Then red1 = xx32 / 10
                'yy32 = CSng(red * (yy2 * cossinba - xx2 * coscosba - zz2 * sinb))
                ''If yy32 / red1 > 10 Then red1 = yy32 / 10
                'xx2 = 0 : yy2 = 0 : zz2 = 1
                'xx33 = CSng(red * (yy2 * cosa + xx2 * sina))
                ''If xx33 / red1 > 10 Then red1 = xx33 / 10
                'yy33 = CSng(red * (yy2 * cossinba - xx2 * coscosba - zz2 * sinb))
                ''If yy33 / red1 > 10 Then red1 = yy33 / 10
                'xx31 = xx31 / red1 : yy31 = yy31 / red1 : xx32 = xx32 / red1 : yy32 = yy32 / red1 : xx33 = xx33 / red1 : yy33 = yy33 / red1
                'g.DrawLine(myPen, xx1, yy1, xx1 + xx33, yy1 + yy33) 'axe Z
                'g.DrawLine(myPen, xx1, yy1, xx1 + xx32, yy1 + yy32) 'axe X
                'g.DrawLine(myPen, xx1, yy1, xx1 + xx31, yy1 + yy31) 'axe y
                'g.DrawString("Y", myFont, myBrush, xx1 + xx31, yy1 + yy31)
                'g.DrawString("X", myFont, myBrush, xx1 + xx32, yy1 + yy32)
                'g.DrawString("Z", myFont, myBrush, xx1 + xx33, yy1 + yy33)
                'For i = 1 To Total_element
                '    Call positionxy(x1(Ele(1, i)), y1(Ele(1, i)), z1(Ele(1, i)), red, xx1, yy1)
                '    Call positionxy(x1(Ele(2, i)), y1(Ele(2, i)), z1(Ele(2, i)), red, xx2, yy2)
                '    g.DrawLine(myPen, xx1, yy1, xx2, yy2)
                'Next
        End Select

    End Sub
    Private Sub Preparation_affichage(ByRef red As Double, ByRef X1() As Double, ByRef y1() As Double, ByRef z1() As Double)
        'détermine les dimensions maximales de la structure
        Dim X_min, X_max, Y_min, Y_max, Z_min, Z_max, Xg, Yg, Zg, red1 As Double
        Dim i As Integer
        Xg = 0 : Yg = 0 : Zg = 0
        Select Case Type_probleme
            Case 1, 2 'espace 2D
                X_min = X_noe(1) : X_max = X_noe(1) : Y_min = Y_noe(1) : Y_max = Y_noe(1)
                For i = 2 To Total_noeud
                    If X_min > X_noe(i) Then X_min = X_noe(i)
                    If X_max < X_noe(i) Then X_max = X_noe(i)
                    If Y_min > Y_noe(i) Then Y_min = Y_noe(i)
                    If Y_max < Y_noe(i) Then Y_max = Y_noe(i)
                Next i
                'calcul du centre de la structure
                Xg = (X_min + X_max) / 2
                Yg = (Y_min + Y_max) / 2
                'détermination des nouvelles coordonnées par rapport au barycentre et recherche des distances Max
                X_max = 0 : Y_max = 0
                For i = 1 To Total_noeud
                    X1(i) = X_noe(i) - Xg
                    y1(i) = Y_noe(i) - Yg
                Next i
                'détermination du coefficient d'amplification: red
                red = (PBox1.Width - 50) / Xg : red1 = (PBox1.Height - 50) / Yg
                If red1 < red Then red = red1
                red = red / 2
            Case 3, 4 'espace 3D   
                X_min = X_noe(1) : X_max = X_noe(1) : Y_min = Y_noe(1) : Y_max = Y_noe(1) : Z_min = Z_noe(1) : Z_max = Z_noe(1)
                For i = 2 To Total_noeud
                    If X_min > X_noe(i) Then X_min = X_noe(i)
                    If X_max < X_noe(i) Then X_max = X_noe(i)
                    If Y_min > Y_noe(i) Then Y_min = Y_noe(i)
                    If Y_max < Y_noe(i) Then Y_max = Y_noe(i)
                    If Z_min > Z_noe(i) Then Z_min = Z_noe(i)
                    If Z_max < Z_noe(i) Then Z_max = Z_noe(i)
                Next i
                'calcul du centre de la structure
                Xg = (X_min + X_max) / 2
                Yg = (Y_min + Y_max) / 2
                Zg = (Z_min + Z_max) / 2
                'détermination des nouvelles coordonnées par rapport au barycentre et recherche des distances Max
                X_max = 0 : Y_max = 0 : Z_max = 0
                For i = 1 To Total_noeud
                    X1(i) = X_noe(i) - Xg
                    y1(i) = Y_noe(i) - Yg
                    z1(i) = Z_noe(i) - Zg
                    If X_max < Abs(y1(i) - X1(i) * Cos(PI / 4)) Then X_max = Abs(y1(i) - X1(i) * Cos(PI / 4))
                    If X_max < Abs(y1(i) + X1(i) * Cos(PI / 4)) Then X_max = Abs(y1(i) + X1(i) * Cos(PI / 4))
                    If Z_max < Abs(z1(i) - X1(i) * Cos(PI / 4)) Then Z_max = Abs(z1(i) - X1(i) * Cos(PI / 4))
                    If Z_max < Abs(z1(i) + X1(i) * Cos(PI / 4)) Then Z_max = Abs(z1(i) + X1(i) * Cos(PI / 4))
                Next i
                'détermination du coefficient d'amplification: red
                red = (PBox1.Width - 50) / ((2 * X_max)) : red1 = (PBox1.Height - 50) / ((2 * Z_max))
                If red1 < red Then red = red1
        End Select
    End Sub
    Private Sub posxy(ByVal x1 As Double, ByVal y1 As Double, ByVal z1 As Double, ByRef csx As Single, _
    ByRef csy As Single, ByVal red As Double)

        Dim Yy, Xx As Double
        Xx = (PBox1.Width / 2)
        Yy = (PBox1.Height / 2)
        Select Case Type_probleme
            Case 1, 2
                csx = CSng(x1 * red + Xx)
                csy = CSng(Yy - y1 * red) 'l'axe Y du PBox1 est l'inverse du Y de la structure

            Case 3, 4
                csy = CInt(-red * z1 + Yy + x1 * Cos(PI / 4) * red)
                csx = CInt(red * y1 + Xx - x1 * Sin(PI / 4) * red)
        End Select
    End Sub
    Private Sub Affichage_noeud(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim red As Double
        Dim i As Integer
        Dim xx1, yy1 As Single
        Dim g As Graphics = pe.Graphics
        Dim myPen As New Pen(Color.Blue, 1)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Blue)
        Dim X1(Total_noeud), y1(Total_noeud), z1(Total_noeud) As Double
        Call Preparation_affichage(red, X1, y1, z1)
        Select Case Type_probleme
            Case 1, 2
                For i = 1 To Total_noeud
                    Call posxy(X1(i), y1(i), 0, xx1, yy1, red)
                    g.FillEllipse(myBrush, xx1 - 3, yy1 - 3, 6, 6)
                    xx1 = xx1 + 3 ' = noe_origine  'noeud 1 de l'élément i
                    yy1 = yy1 + 3
                    g.DrawString(CStr(i), myFont, myBrush, xx1, yy1)
                Next i
            Case 3, 4
                For i = 1 To Total_noeud
                    Call positionxy(X1(i), y1(i), z1(i), red, xx1, yy1)
                    g.FillEllipse(myBrush, xx1 - 3, yy1 - 3, 6, 6)
                    xx1 = xx1 + 3 ' = noe_origine  'noeud 1 de l'élément i
                    yy1 = yy1 + 3
                    g.DrawString(CStr(i), myFont, myBrush, xx1, yy1)
                Next i
        End Select

    End Sub
    Private Sub Affichage_appui(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim red As Double
        Dim i As Integer
        Dim xx1, yy1, x2, y2 As Single
        Dim g As Graphics = pe.Graphics
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Red)
        Dim X1(Total_noeud), y1(Total_noeud), z1(Total_noeud) As Double
        Call Preparation_affichage(red, X1, y1, z1)
        Select Case Type_probleme
            Case 1, 2
                For i = 1 To Total_noeud
                    If Appui(i) = True Then
                        Call posxy(X1(i), y1(i), 0, xx1, yy1, red)
                        'noeud bloqué suivant x et y, rotation libre
                        If R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 + 6, yy1 + 5)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 - 9, yy1 + 12)
                            g.DrawLine(myPen, xx1 - 2, yy1 + 5, xx1 - 5, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 2, yy1 + 5, xx1 - 1, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 6, yy1 + 5, xx1 + 3, yy1 + 12)
                        End If
                        'noeud bloqué suivant x et y, rotation bloquée = encastrement parfait
                        If R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = False Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.FillRectangle(myBrush, xx1 - 4, yy1 - 4, 8, 8)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 + 6, yy1 + 5)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 - 9, yy1 + 12)
                            g.DrawLine(myPen, xx1 - 2, yy1 + 5, xx1 - 5, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 2, yy1 + 5, xx1 - 1, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 6, yy1 + 5, xx1 + 3, yy1 + 12)
                        End If
                        'noeud  libre suivant x et bloqué suivant y, rotation libre
                        If R_appui(1, i) = True And R_appui(2, i) = False And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 - 9, yy1 + 6, xx1 + 14, yy1 + 6)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 7, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 7, yy1 + 8, 5, 5)
                        End If
                        'noeud  libre suivant x et bloqué suivant y, rotation bloquée
                        If R_appui(1, i) = True And R_appui(2, i) = False And R_appui(6, i) = False Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.FillRectangle(myBrush, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 - 9, yy1 + 6, xx1 + 14, yy1 + 6)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 7, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 7, yy1 + 8, 5, 5)
                        End If
                        'noeud  bloqué suivant x et libre suivant y, rotation libre
                        If R_appui(1, i) = False And R_appui(2, i) = True And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 + 6, yy1 - 9, xx1 + 6, yy1 + 14)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 - 7, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 + 7, 5, 5)
                        End If
                        'noeud  bloqué suivant x et libre suivant y, rotation bloquée
                        If R_appui(1, i) = False And R_appui(2, i) = True And R_appui(6, i) = False Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.FillRectangle(myBrush, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 + 6, yy1 - 9, xx1 + 6, yy1 + 14)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 - 7, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 + 7, 5, 5)
                        End If
                    End If
                Next i
            Case 3, 4
                For i = 1 To Total_noeud
                    If Appui(i) = True Then
                        Call positionxy(X1(i), y1(i), z1(i), red, xx1, yy1)
                        'noeud bloqué suivant x et y, rotation libre
                        If R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 + 6, yy1 + 5)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 - 9, yy1 + 12)
                            g.DrawLine(myPen, xx1 - 2, yy1 + 5, xx1 - 5, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 2, yy1 + 5, xx1 - 1, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 6, yy1 + 5, xx1 + 3, yy1 + 12)
                        End If
                        'noeud bloqué suivant x et y, rotation bloquée = encastrement parfait
                        If R_appui(1, i) = False And R_appui(2, i) = False And R_appui(6, i) = False Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.FillRectangle(myBrush, xx1 - 4, yy1 - 4, 8, 8)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 + 6, yy1 + 5)
                            g.DrawLine(myPen, xx1 - 6, yy1 + 5, xx1 - 9, yy1 + 12)
                            g.DrawLine(myPen, xx1 - 2, yy1 + 5, xx1 - 5, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 2, yy1 + 5, xx1 - 1, yy1 + 12)
                            g.DrawLine(myPen, xx1 + 6, yy1 + 5, xx1 + 3, yy1 + 12)
                        End If
                        'noeud  libre suivant x et bloqué suivant y, rotation libre
                        If R_appui(1, i) = True And R_appui(2, i) = False And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 - 9, yy1 + 6, xx1 + 14, yy1 + 6)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 7, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1, yy1 + 8, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 7, yy1 + 8, 5, 5)
                        End If
                        'noeud  bloqué suivant x et libre suivant y, rotation libre
                        If R_appui(1, i) = False And R_appui(2, i) = True And R_appui(6, i) = True Then
                            Dim myPen As New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 - 4, yy1 - 4, 8, 8)
                            myPen = New Pen(Color.Red, 3)
                            g.DrawLine(myPen, xx1 + 6, yy1 - 9, xx1 + 6, yy1 + 14)
                            myPen = New Pen(Color.Red, 1)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 - 7, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1, 5, 5)
                            g.DrawEllipse(myPen, xx1 + 8, yy1 + 7, 5, 5)
                        End If
                    End If
                Next i
        End Select
    End Sub
    Private Sub Affichage_Element(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim red As Double
        Dim i As Integer
        Dim orix1, oriy1, xx1, yy1, x2, y2 As Single
        Dim g As Graphics = pe.Graphics
        Dim myPen As New Pen(Color.Black, 1)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim X1(Total_noeud), y1(Total_noeud), z1(Total_noeud) As Double
        Call Preparation_affichage(red, X1, y1, z1)
        Select Case Type_probleme
            Case 1, 2
                For i = 1 To Total_element
                    Call posxy(X1(Ele(1, i)), y1(Ele(1, i)), 0, xx1, yy1, red) ' = noe_origine  'noeud 1 de l'élément i
                    Call posxy(X1(Ele(2, i)), y1(Ele(2, i)), 0, x2, y2, red) ' = noe_extremite 'noeud 2 de l'élément i
                    xx1 = Abs(x2 + xx1) / 2
                    yy1 = Abs(y2 + yy1) / 2
                    xx1 = CSng(xx1 + 5)  ' = noe_origine  'noeud 1 de l'élément i
                    yy1 = CSng(yy1 + 5)
                    g.DrawString(CStr(i), myFont, myBrush, xx1, yy1)
                Next i
            Case 3, 4
                For i = 1 To Total_element
                    Call positionxy(X1(Ele(1, i)), y1(Ele(1, i)), z1(Ele(1, i)), red, xx1, yy1) ' = noe_origine  'noeud 1 de l'élément i
                    Call positionxy(X1(Ele(2, i)), y1(Ele(2, i)), z1(Ele(2, i)), red, x2, y2) ' = noe_extremite 'noeud 2 de l'élément i
                    xx1 = Abs(x2 + xx1) / 2
                    yy1 = Abs(y2 + yy1) / 2
                    xx1 = CSng(xx1 + 5)  ' = noe_origine  'noeud 1 de l'élément i
                    yy1 = CSng(yy1 + 5)
                    g.DrawString(CStr(i), myFont, myBrush, xx1, yy1)
                Next i
        End Select
    End Sub
    Private Sub Affichage_Ordonne(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim red As Double
        Dim i As Integer
        Dim xx1, yy1 As Single
        Dim g As Graphics = pe.Graphics
        Dim myPen As New Pen(Color.Blue, 1)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Blue)
        Dim X1(Total_noeud), y1(Total_noeud), z1(Total_noeud) As Double
        Call Preparation_affichage(red, X1, y1, z1)
        Select Case Type_probleme
            Case 1, 2
                For i = 1 To Total_noeud
                    Call posxy(X1(i), y1(i), 0, xx1, yy1, red)
                    g.DrawLine(myPen, xx1, CSng(yy1 + NuD1.Value), xx1, CSng(yy1 - NuD1.Value))
                Next i
            Case 3, 4
                For i = 1 To Total_noeud
                    Call positionxy(X1(i), y1(i), z1(i), red, xx1, yy1)
                    g.FillEllipse(myBrush, xx1 - 3, yy1 - 3, 6, 6)
                    xx1 = xx1 + 3 ' = noe_origine  'noeud 1 de l'élément i
                    yy1 = yy1 + 3
                    g.DrawString(CStr(i), myFont, myBrush, xx1, yy1)
                Next i
        End Select

    End Sub
    Private Sub positionxy(ByVal x1 As Double, ByVal y1 As Double, ByVal z1 As Double, ByVal red As Double, _
                     ByRef csx As Single, ByRef csy As Single)
        '    'Fonction de translation :
        Dim Yy, Xx As Double
        Yy = zoom '/ (10.0# - (z1 * cosb + y1 * sinsinba - x1 * sincosba))
        Xx = red * ((y1 * cosa + x1 * sina) * Yy)
        csx = CSng(Xx + PBox1.Width / 2) 'Int(dXXshift) +
        Xx = red * ((y1 * cossinba - x1 * coscosba - z1 * sinb) * Yy)
        csy = CSng(Xx + PBox1.Height / 2) 'Int(dYYshift) + 
    End Sub

#Region "Gestion des coches"
    Private Sub chkbNoe_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkbNoe.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub chkbBarre_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkbBarre.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub chkbappui_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkbAppui.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub ChkbOrdonne_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbOrdonne.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub ChkbDeformee_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbDeformee.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub ChkbMz_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbMz.CheckedChanged
        PBox1.Refresh()
    End Sub
    Private Sub ChkbFy_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbFy.CheckedChanged
        PBox1.Refresh()
    End Sub
#End Region
#Region "Gestion des Rbtn de selection multiple"
    Private Sub RbtnLB2SelMultiSimple_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RbtnLB2SelMultiSimple.CheckedChanged
        If RbtnLB2SelMultiSimple.Checked = True Then LB2.SelectionMode = SelectionMode.MultiSimple
    End Sub
    Private Sub RbtnLB2SelMultiEtendu_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RbtnLB2SelMultiEtendu.CheckedChanged
        If RbtnLB2SelMultiEtendu.Checked = True Then LB2.SelectionMode = SelectionMode.MultiExtended
    End Sub
#End Region
#Region "Gestion des cas de charges et de combinaisons"
    Private Sub ChkbCas_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkbCas.CheckedChanged
        Call Gestion_Charge_Combinaison()
    End Sub
    Private Sub ChkbComb_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkbComb.CheckedChanged
        Call Gestion_Charge_Combinaison()
    End Sub
    Private Sub Gestion_Charge_Combinaison()
        Dim j, total_charge, Total_comb As Integer
        For j = 1 To 4 ', Total_combinaison(4) 
            total_charge = total_charge + Total_cas_de_charge(j)
        Next
        For j = 1 To 4 ',
            Total_comb = Total_comb + Total_combinaison(j)
        Next
        If ChkbCas.Checked = True Then
            If ChkbComb.Checked = False Then
                lblCas.Text = "Cas de charges :"
                'Chargement de tous les cas de charge dans la listbox LB2
                LB2.Items.Clear() 'enlever tous les éléments de la précédente collection
                For j = 1 To total_charge
                    LB2.Items.Add(j.ToString)
                    LB2.SetSelected(j - 1, True) 'sélection de toute la collection
                Next
            Else
                lblCas.Text = "Cas de charges et de combinaisons:"
                'Chargement de tous les cas de charge dans la listbox LB2
                LB2.Items.Clear() 'enlever tous les éléments de la précédente collection
                For j = 1 To total_charge
                    LB2.Items.Add(j.ToString)
                    LB2.SetSelected(j - 1, True) 'sélection de toute la collection
                Next
                For j = 1 To Total_comb
                    LB2.Items.Add(j.ToString)
                    LB2.SetSelected(j - 1, True) 'sélection de toute la collection
                Next
            End If
        Else
            If ChkbComb.Checked = False Then
                lblCas.Text = "---------"
                LB2.Items.Clear() 'enlever tous les éléments de la précédente collection
            Else
                lblCas.Text = "Cas de combinaisons:"
                'Chargement de tous les cas de charge dans la listbox LB2
                LB2.Items.Clear() 'enlever tous les éléments de la précédente collection
                For j = 1 To Total_comb
                    LB2.Items.Add(j.ToString)
                    LB2.SetSelected(j - 1, True) 'sélection de toute la collection
                Next
            End If
        End If
    End Sub
#End Region


    Private Sub NuD1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NuD1.ValueChanged
        PBox1.Refresh()
    End Sub


End Class