Imports System.Math
Module Poubelle

    Private Sub poubelle()

        'Private Sub Vpinv(ByRef structure_OK As Boolean, ByVal Kgt(,) As Double, _
        '                ByRef Cr() As Double, ByVal i_pas As Integer)

        '    'Entre: kgt    Matrice globale de rigidit tangente
        '    '        i_pas  N de cas tudi
        '    '       
        '    'Sortie: Cr() Coefficient d'amplification critique pour le cas tudi
        '    '************************************************************
        '    '* calculate smallest eigenvalue and associated eigenvector *
        '    '* by the Gauss-Jordan and the power methods                *
        '    '* -------------------------------------------------------- *
        '    '* INPUTS:                                                  *
        '    '*         eps   : smallest number in double precision      *
        '    '*         dta   : required precision                       *
        '    '*         maxit : maximum number of iterations             *
        '    '*         n     : size of real square matrix A(n,n)        *
        '    '*         A     : real square matrix A(n,n)                *
        '    '* OUTPUTS:                                                 *
        '    '*         it    : error indicator: -1=no convergence,      *
        '    '*                 0=method cannot be applied,              *
        '    '*                 1=convergence ok.                        *
        '    '*        lambda : smallest eigenvalue (in absolute value)  *
        '    '*                 of input matrix A(n,n)                   *
        '    '*         X     : associated eigenvector                   *
        '    '************************************************************

        '    Dim Det, dta, eps, gamma As Double '
        '    Dim i, i1, i3, It, j, j1, j3, L, Maxit As Integer
        '    i1 = 3 * (Total_noeud - Total_appui)
        '    Dim A(i1, i1), X(i1) As Double
        '    'Initialisation
        '    dta = 0.0000000001 ' Precision
        '    eps = 0.0000000001 ' Epsilon  
        '    Maxit = 32 'Maximum number of iterations
        '    i1 = 0 : j1 = 0
        '    For i = 1 To 3 * Total_noeud 'ligne
        '        i3 = CInt(Int((i + 2) / 3)) : i1 = i1 + 1
        '        If Appui(i3) = False Then 'test si noeud n'est pas un appuiOr i3 = 2
        '            j1 = 0
        '            For j = 1 To 3 * Total_noeud 'colonne la matrice K est symtrique, on ne rentre que le triangle suprieur, colonne par colonne
        '                j3 = CInt(Int((j + 2) / 3)) : j1 = j1 + 1
        '                If Appui(j3) = False Then 'test si noeud n'est pas un appuiOr j3 = 2
        '                    A(i1, j1) = Kgt(i, j)
        '                Else
        '                    j1 = j1 - 1
        '                End If
        '            Next
        '        Else
        '            i1 = i1 - 1
        '        End If
        '    Next

        '    'Calcul de la matrice inverse
        '    Call MATINV(3 * (Total_noeud - Total_appui), A, Det, structure_OK) '   inverse of A is now in A X,
        '    'For i = 1 To 3 * (Total_noeud - Total_appui)
        '    '    For j = 1 To 3 * (Total_noeud - Total_appui)
        '    '        If Abs(A(i, j)) < 0.000001 Then A(i, j) = 0
        '    '    Next
        '    'Next
        '    If Abs(Det) > eps Then
        '        Call PWM(eps, dta, 3 * (Total_noeud - Total_appui), A, It, gamma, X, L, Maxit)
        '        If It = 1 Then gamma = 1.0# / gamma
        '    End If
        '    If It + 1 = 0 Then
        '        MsgBox(" No convergence !!!", MsgBoxStyle.Critical, "Module VpInv")
        '        structure_OK = False
        '    ElseIf It + 1 = 1 Then
        '        MsgBox(" Method does not apply.", MsgBoxStyle.Critical, "Module VpInv")
        '        structure_OK = False
        '    Else
        '        Cr(i_pas) = gamma '  Eigenvalue: " & Cr(i_pas))
        '        '"  Eigenvector:")
        '        'For I = 1 To n
        '        '    Console.WriteLine("  " & X(I))
        '        'Next I
        '    End If
        '    '" Number of iterations: " & l)
        '    Erase A
        'End Sub

        'Private Sub MATINV(ByVal n As Integer, ByRef A(,) As Double, ByRef det As Double, ByRef structure_OK As Boolean) 'ByRef X() As Double,
        '    '*******************************************
        '    '*  SOLVING A LINEAR MATRIX SYSTEM AX = B  *
        '    '*  with Gauss-Jordan method using full    *
        '    '*  pivoting at each step. During the pro- *
        '    '* cess, original A and B matrices are     *
        '    '* destroyed to spare storage location.    *
        '    '* --------------------------------------- *
        '    '* INPUTS:    A   MATRIX N*N               *
        '    '* --------------------------------------- *
        '    '* OUTPUS:    A   INVERSE OF A N*N         *
        '    '*            DET  DETERMINANT OF A        *
        '    '* --------------------------------------- *
        '    Dim i, ik, j, jk, k As Integer
        '    Dim PC(n), PL(n) As Integer
        '    Dim CS(n) As Double
        '    Dim PV, PAV, temp, TT As Double
        '    Dim EPSMACH As Double = 0.0000000000000002 'Machine dependant EPSMACH equals here 2E-16
        '    'Initializations
        '    det = 1.0#
        '    For i = 1 To n
        '        PC(i) = 0
        '        PL(i) = 0
        '        CS(i) = 0.0#
        '    Next i

        '    'Main loop
        '    For k = 1 To n
        '        'Searching greatest pivot
        '        PV = A(k, k)
        '        ik = k : jk = k
        '        PAV = Abs(PV)
        '        For i = k To n
        '            For j = k To n
        '                temp = Abs(A(i, j))
        '                If temp > PAV Then
        '                    PV = A(i, j)
        '                    PAV = Abs(PV)
        '                    ik = i : jk = j
        '                End If
        '            Next j
        '        Next i

        '        'Search terminated, the pivot is in location I=IK, J=JK.
        '        'Memorizing pivot location:

        '        PC(k) = jk
        '        PL(k) = ik

        '        'DETERMINANT DET is actualised
        '        'If DET=0, ERROR MESSAGE and STOP
        '        'Machine dependant EPSMACH equals here 2E-16
        '        If ik <> k Then
        '            det = -det
        '        End If
        '        If jk <> k Then
        '            det = -det
        '        End If
        '        det = det * PV
        '        temp = Abs(det)
        '        If temp < EPSMACH Then
        '            MsgBox(" The determinant equals ZERO !!!", MsgBoxStyle.Critical, "Module MatInv")
        '            structure_OK = False
        '            Exit Sub
        '        End If

        '        'POSITIONNING PIVOT IN K,K:}
        '        If ik <> k Then
        '            For i = 1 To n
        '                'EXCHANGE LINES IK and K of matrix A:}
        '                TT = A(ik, i)
        '                A(ik, i) = A(k, i)
        '                A(k, i) = TT
        '            Next i
        '        End If

        '        'PIVOT is at correct line
        '        If jk <> k Then
        '            For i = 1 To n
        '                'EXCHANGE COLUMNS JK and K of matrix A:
        '                TT = A(i, jk)
        '                A(i, jk) = A(i, k)
        '                A(i, k) = TT
        '            Next i
        '        End If

        '        'The PIVOT is at correct column and is located in K,K.
        '        'Column K of matrix A is stored in CS vector then column K is set to zero.
        '        For i = 1 To n
        '            CS(i) = A(i, k)
        '            A(i, k) = 0.0#
        '        Next i

        '        CS(k) = 0.0#
        '        A(k, k) = 1.0#
        '        'Line K of matrix A is modified:
        '        temp = Abs(PV)
        '        If temp < EPSMACH Then
        '            MsgBox(" PIVOT TOO SMALL - STOP", MsgBoxStyle.Critical, "Module MatInv")
        '            structure_OK = False
        '            Exit Sub
        '        End If
        '        For i = 1 To n
        '            A(k, i) = A(k, i) / PV
        '        Next i

        '        'Other lines of matrix A are modified:
        '        For j = 1 To n
        '            If j <> k Then
        '                For i = 1 To n
        '                    'Line J of matrix A is modified:
        '                    A(j, i) = A(j, i) - CS(j) * A(k, i)
        '                Next i
        '            End If
        '        Next j '100
        '        'Line K is ready
        '    Next k 'end K loop

        '    'MATRIX A INVERSION IS DONE - UNSCRAMBLE OF MATRIX A

        '    'EXCHANGE LINES
        '    For i = n To 1 Step -1
        '        ik = Int(PC(i))
        '        If ik <> i Then
        '            'EXCHANGE LINES I and PC(I) of matrix A:
        '            For j = 1 To n
        '                TT = A(i, j)
        '                A(i, j) = A(ik, j)
        '                A(ik, j) = TT
        '            Next j
        '        End If
        '        'NO MORE EXCHANGE is NECESSARY
        '    Next i '200: End of loop i=N to 1 step -1

        '    'EXCHANGE COLUMNS
        '    For j = n To 1 Step -1
        '        jk = Int(PL(j))
        '        If jk <> j Then
        '            'EXCHANGE COLUMNS J ET PL(J) of matrix A:
        '            For i = 1 To n
        '                TT = A(i, j)
        '                A(i, j) = A(i, jk)
        '                A(i, jk) = TT
        '            Next i
        '        End If
        '        'NO MORE EXCHANGE is NECESSARY
        '        'Go to next column.
        '    Next j '300
        '    ' UNSCRAMBLE TERMINATED
        '    Erase PC, CS, PL
        'End Sub
        'Private Sub PWM(ByVal eps As Double, ByVal dta As Double, ByVal n As Integer, ByVal A(,) As Double, _
        '                ByRef it As Integer, ByRef gamma As Double, ByRef X() As Double, ByRef L As Integer, ByVal maxit As Integer) '1000:   'Subroutine PWM(eps,dta,m,n,A,it,gamma,X)
        '    '************************************************************
        '    '* calculate greatest eigenvalue and associated eigenvector *
        '    '* by the power method                                      *
        '    '* -------------------------------------------------------- *
        '    '* INPUTS:                                                  *
        '    '*         eps   : smallest number in double precision      *
        '    '*         dta   : required precision                       *
        '    '*         maxit : maximum number of iterations             *
        '    '*         n     : size of real square matrix A(n,n)        *
        '    '*         A     : real square matrix A(n,n)                *
        '    '* OUTPUTS:                                                 *
        '    '*         it    : error indicator: -1=no convergence,      *
        '    '*                 0=method cannot be applied,              *
        '    '*                 1=convergence ok.                        *
        '    '*         gamma : greatest eigenvalue (in absolute value)  *
        '    '*                 of input matrix A(n,n)                   *
        '    '*         X1    : associated eigenvector                   *
        '    '************************************************************
        '    Dim X0(n) As Double
        '    Dim i, j As Integer
        '    Dim phi, s As Double
        '    For i = 1 To n
        '        X0(i) = 1.0# / Sqrt(i)
        '    Next i
        '    it = -1 : L = 1
        '    Do
        '        gamma = 0.0#
        '        For i = 1 To n
        '            X(i) = 0.0#
        '            For j = 1 To n
        '                X(i) = X(i) + A(i, j) * X0(j)
        '            Next j
        '            If Abs(X(i)) > Abs(gamma) Then gamma = X(i)
        '        Next i
        '        If Abs(gamma) < eps Then
        '            it = 0
        '        Else
        '            For i = 1 To n
        '                X(i) = X(i) / gamma
        '            Next i
        '            phi = 0.0#
        '            For i = 1 To n
        '                s = Abs(X(i) - X0(i))
        '                If s > phi Then phi = s
        '            Next i
        '            If phi < dta Then
        '                it = 1
        '            Else
        '                For i = 1 To n
        '                    X0(i) = X(i)
        '                Next i
        '                L = L + 1
        '            End If
        '        End If
        '    Loop While it = -1 And L <= maxit
        '    Erase X0
        'End Sub

        'Private Sub MatVec(ByVal KG(,) As Double, ByVal dxyz() As Double, ByRef Hxyz() As Double)
        '    Dim i, j, k As Integer
        '    k = 1
        '    For i = 1 To 3 * Total_noeud
        '        For j = 1 To 3 * Total_noeud
        '            Hxyz(k) = Hxyz(k) + KG(i, j) * dxyz(j)
        '        Next
        '        k = k + 1
        '    Next
        'End Sub


        ''--> Debogage de l'application: 
        ''Dim myStreamwriter As StreamWriter
        ''passage = passage + 1
        ''Dim fich As String
        ''fich = "detail_calcul_" + CStr(passage) + ".txt"
        ''Dim fs As New FileStream(fich, FileMode.OpenOrCreate) ', FileAccess.Write)
        ''Dim sw As New StreamWriter(fs)
        ''--> Dclarations de variables:
        ''nouvelles variables
        'Dim i, j, k, k1, reponse As Integer
        'Dim FN(3, Total_noeud), Pdelta As Double
        'Dim FB(6, Total_element), Dp(3, Total_noeud), Dp1(3, Total_noeud), Du(2, Total_noeud), Du1(2, Total_noeud) As Double
        'Dim Sr(Total_element), Dxyz(3 * Total_noeud), Hxyz(3 * Total_noeud) As Double
        'Dim msg As String
        'ReDim IterPdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2)), PdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2))
        'MaxPdeltaTol = 0.03 : MaxIter = 20
        'Dim X_noe1(Total_noeud), Y_noe1(Total_noeud) As Double
        'For j = 1 To Total_noeud
        '    X_noe1(j) = X_noe(j) : Y_noe1(j) = Y_noe(j)
        'Next
        'For i = Total_cas_de_charge(1) + 1 To Total_cas_de_charge(1) + Total_cas_de_charge(2)
        '    'dtermination des ractions d'appui, des efforts sur les barres et des dplacements 
        '    'pour chaque cas de charge
        '    For j = 1 To Total_noeud
        '        Dp1(1, j) = 0 : Dp1(2, j) = 0
        '        Dp(1, j) = 0 : Dp(2, j) = 0
        '    Next
        '    IterPdeltaTol(i) = 1 : reponse = 0 : PdeltaTol(i) = 1
        '    'itration n1
        '    Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr)
        '    Call Appui_elastique(Kg)
        '    Call C_Limit_Kg(Kg, structure_OK) : If structure_OK = False Then Exit Sub
        '    Select Case Type_probleme
        '        Case 1 'treillis
        '            Call Second_Membre_Treillis(L, FN, i)
        '        Case 2 'portique
        '            If Def_Tranchant = True Then
        '                'calcul du vecteur force avec prise en compte de l'effort tranchant
        '                Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
        '            Else
        '                'calcul du vecteur force sans prise en compte de l'effort tranchant
        '                Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
        '            End If
        '    End Select
        '    Call C_Limit_FN(FN)
        '    Call Resol(FN, Kg, Dp, structure_OK, i) : If structure_OK = False Then Exit Sub
        '    IterPdeltaTol(i) = 2
        '    'itrations suivantes
        '    Do
        '        For j = 1 To Total_noeud
        '            Dp1(1, j) = Dp(1, j) : Dp1(2, j) = Dp(2, j) : Dp1(3, j) = Dp(3, j)
        '            X_noe(j) = X_noe1(j) + Dp1(1, j) : Y_noe(j) = Y_noe1(j) + Dp1(2, j)
        '            'X_noe(j) = X_noe(j) + Dp1(1, j) : Y_noe(j) = Y_noe(j) + Dp1(2, j)
        '        Next
        '        Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr)
        '        Call Appui_elastique(Kg)
        '        Call C_Limit_Kg(Kg, structure_OK) : If structure_OK = False Then Exit Sub
        '        'Select Case Type_probleme
        '        '    Case 1 'treillis
        '        '        Call Second_Membre_Treillis(L, FN, i)
        '        '    Case 2 'portique
        '        '        If Def_Tranchant = True Then
        '        '            'calcul du vecteur force avec prise en compte de l'effort tranchant
        '        '            Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
        '        '        Else
        '        '            'calcul du vecteur force sans prise en compte de l'effort tranchant
        '        '            Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
        '        '        End If
        '        'End Select
        '        'Call C_Limit_FN(FN)
        '        Call Resol(FN, Kg, Dp, structure_OK, i) : If structure_OK = False Then Exit Sub
        '        k = 1
        '        For j = 1 To Total_noeud
        '            Dxyz(k) = Dp(1, j) - Dp1(1, j) : Dxyz(k + 1) = Dp(2, j) - Dp1(2, j) : Dxyz(k + 2) = Dp(3, j) - Dp1(3, j)
        '            k = k + 3
        '        Next
        '        Call MatVec(Kg, Dxyz, Hxyz)
        '        'addition de forces
        '        k = 1
        '        For j = 1 To Total_noeud
        '            FN(1, j) = FN(1, j) + Hxyz(k)
        '            FN(2, j) = FN(2, j) + Hxyz(k + 1)
        '            FN(3, j) = FN(3, j) + Hxyz(k + 2)
        '            k = k + 3
        '        Next
        '        ' k1 = 0
        '        'If IterPdeltaTol(i) >= 3 Then
        '        '    PdeltaTol(i) = 0
        '        'For j = 1 To Total_noeud
        '        '    If Appui(j) = True Then
        '        '        j = j + 1 'test si noeud est un appui
        '        '        If j > Total_noeud Then Exit For
        '        '    End If
        '        '    'PdeltaTol(i) = 1
        '        '    ''For k = 1 To 2
        '        '    ''    Du1(k, j) = Du(k, j) 'difference de dformation sur itration prcdente
        '        '    ''    Du(k, j) = Abs(Dp1(k, j) - Dp(k, j)) 'difference de dformation sur itration actuelle
        '        '    ''    PdeltaTol(i) = 1 'pour viter le test
        '        '    ''Next
        '        '    'Else
        '        '    'For k = 1 To 2
        '        '    '    If Dp(k, j) > 0.000000000001 Then
        '        '    '        Pdelta = Abs((Dp1(k, j) - Dp(k, j)) / Dp(k, j))
        '        '    '        If Pdelta < MaxPdeltaTol Then

        '        '    '            Exit Do
        '        '    '        End If
        '        '    '    End If
        '        '    '    'If Abs(Dp1(k, j) - Dp(k, j)) > Du(k, j) * 1.01 And reponse = 0 Then '1.005 Then '0.5% pour tenir compte de la prcision du calcul numrique
        '        '    '    '    msg = "La structure est instable au second ordre (sous effet P-delta)" & vbCrLf & _
        '        '    '    '        "Augmentation de la divergence de dformation sous structure dforme" & vbCrLf & _
        '        '    '    '        "Itration n" & CStr(IterPdeltaTol(i)) & " Noeud n " & CStr(j) & " delta-dformation = " & CStr(Abs(Dp1(k, j) - Dp(k, j))) & vbCrLf & _
        '        '    '    '        "pour Itration n" & CStr(IterPdeltaTol(i) - 1) & " delta-dformation = " & CStr(Du(k, j)) & vbCrLf & _
        '        '    '    '        "Voulez-vous continuer (=OUI) ou arreter le calcul  cette itration (=NON)?"
        '        '    '    '    reponse = MsgBox(msg, MsgBoxStyle.YesNo, title)
        '        '    '    '    If reponse = vbNo Then 'vbYes
        '        '    '    '        structure_OK = False
        '        '    '    '        Exit Sub
        '        '    '    '    End If
        '        '    '    'End If 'Else
        '        '    '    'Du1(k, j) = Du(k, j) 'difference de dformation sur itration prcdente
        '        '    '    'Du(k, j) = Abs(Dp1(k, j) - Dp(k, j)) 'difference de dformation sur itration actuelle
        '        '    '    ''% du taux de difference de dformation
        '        '    '    'If Du(k, j) <> 0 Then
        '        '    '    '    PdeltaTol(i) = PdeltaTol(i) + Abs(Du(k, j) / Dp(k, j))
        '        '    '    '    k1 = k1 + 1 'nbre d'quation
        '        '    '    'End If
        '        '    'Next
        '        'Next
        '        'End If

        '        'If k1 <> 0 Then PdeltaTol(i) = PdeltaTol(i) / k1 'moyenne en % du taux de difference de dformation
        '        'Exit Do
        '        IterPdeltaTol(i) = IterPdeltaTol(i) + 1
        '        If IterPdeltaTol(i) = 4 Then Exit Do
        '    Loop Until IterPdeltaTol(i) = MaxIter + 1 'Or PdeltaTol(i) < MaxPdeltaTol
        '    IterPdeltaTol(i) = IterPdeltaTol(i) - 1
        '    Call Resultat(Dp, Rot, L, kg0, FB, i)
        'Next
        'Erase FN, FB, Dp, Dp1, Sr

        '''--> Debogage de l'application:
        ''sw.Write(msgg)
        ''sw.Close()
        ''msgg = "" 'remise  0 de la variable

        '    Private Sub Flambement(ByRef structure_OK As Boolean, ByRef Kg(,) As Double, ByRef kg0(,) As Double, _
        '                                       ByRef L() As Double, ByRef Rot(,) As Double)
        '        'Dtermination du coefficient d'amplification critique et de la valeur de la dforme sous le mode de
        '        'flambement correspondant
        '        '--> Dclarations de variables:
        '        'nouvelles variables
        '        Dim FN(3, Total_noeud) As Double
        '        Dim FB(6, Total_element), Dp(3, Total_noeud) As Double
        '        Dim Fapp(3, Total_noeud) As Double
        '        Dim Sr(Total_element) As Double
        '        Dim X_noe1(Total_noeud), Y_noe1(Total_noeud) As Double
        '        Dim i, j, k As Integer
        '        Dim det0, det1 As Double
        '        Dim msg As String
        '        ReDim IterPdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2)), PdeltaTol(Total_cas_de_charge(1) + Total_cas_de_charge(2))
        '        Dim ForPN1(,,), ForP1(,,,), CpleP1(,,), ForL11(,,,), ForL12(,,,) As Double

        '        For j = 1 To Total_noeud
        '            X_noe1(j) = X_noe(j) : Y_noe1(j) = Y_noe(j)
        '        Next
        '        '--> Calcul du dterminant de la matrice de rigidit de la structure initiale non dforme
        '        Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr)
        '        Call Appui_elastique(Kg)
        '        Call C_Limit_Kg(Kg, Fapp, structure_OK) : If structure_OK = False Then Exit Sub
        '        Dim Mat1(3 * Total_noeud, 3 * Total_noeud), Mat12(3 * Total_noeud, 3 * Total_noeud) As Double
        '        For i = 1 To 3 * Total_noeud
        '            For j = 1 To 3 * Total_noeud
        '                Mat1(i, j) = Kg(i, j) : Mat12(i, j) = Kg(i, j)
        '            Next
        '        Next
        '        Call Determinant(3 * Total_noeud, Mat12, det0)
        '        Call Determinant1(3 * Total_noeud, Mat12, 0.0000000000001, det0)
        '        If det0 < 0 Then
        '            msg = "Le dterminant de la matrice de rigidit est ngatif." & vbCrLf & _
        '                "Il est gal  : " & CStr(det0)
        '            MsgBox(msg, MsgBoxStyle.Critical, "Analyse non linaire: module Flambement")
        '            structure_OK = False : Exit Sub
        '        End If

        '        For i = 1 To 3 * Total_noeud
        '            For j = 1 To 3 * Total_noeud
        '                If Mat1(i, j) <> Kg(i, j) Then Stop
        '            Next
        '        Next
        '        'Recherche pour chaque cas de charge renseign dans le fichier de donnes du coefficient critique de flambement
        '        For i = Total_cas_de_charge(1) + 1 To Total_cas_de_charge(1) + Total_cas_de_charge(2)
        '            '--> Calcul des dplacements sous chargement initial
        '            For j = 1 To Total_noeud
        '                Dp(1, j) = 0 : Dp(2, j) = 0
        '            Next
        '            Select Case Type_probleme
        '                Case 1 'treillis
        '                    Call Second_Membre_Treillis(L, FN, i)
        '                Case 2 'portique
        '                    If Def_Tranchant = True Then
        '                        'calcul du vecteur force avec prise en compte de l'effort tranchant
        '                        Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
        '                    Else
        '                        'calcul du vecteur force sans prise en compte de l'effort tranchant
        '                        Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
        '                    End If
        '            End Select
        '            Call Resol(FN, Fapp, Mat1, Dp, structure_OK, i) : If structure_OK = False Then Exit Sub
        '            For j = 1 To Total_noeud
        '                X_noe(j) = X_noe1(j) + Dp(1, j) : Y_noe(j) = Y_noe1(j) + Dp(2, j)
        '            Next
        '            '--> Calcul du dterminant de la matrice de rigidit avec dformation sous charge initiale
        '            Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr)
        '            Call Appui_elastique(Kg)
        '            Call C_Limit_Kg(Kg, Fapp, structure_OK) : If structure_OK = False Then Exit Sub
        '            For k = 1 To 3 * Total_noeud
        '                For j = 1 To 3 * Total_noeud
        '                    Mat12(k, j) = Kg(k, j)
        '                Next
        '            Next
        '            For j = 1 To Total_noeud * 3
        '                If Abs(Mat12(j, j)) < 0.000001 Then Mat12(j, j) = 1
        '                'Dim dd As Double
        '                'If j = 15 Then dd = Abs(Mat12(j, j))
        '            Next
        '            Call Determinant1(3 * Total_noeud, Mat12, 0.0000000000001, det1)
        '            If det0 / det1 > 1 Then '  If det1 / det0 > 1 Then
        '                msg = "La divergence d'quilibre ne peut tre atteinte du fait de la compression" & vbCrLf & _
        '                    "insignifiante ou inexistante.Votre structure est peut-tre constitue par" & vbCrLf & _
        '                    "un tirant ou la compression est inexistante."
        '                MsgBox(msg, MsgBoxStyle.Critical, "Analyse non linaire: module Flambement")
        '                structure_OK = False : Exit Sub
        '            ElseIf det0 / det1 < MaxPdeltaTol Then 'det1 / det0 < MaxPdeltaTol Then
        '                msg = "Votre structure flambe sous chargement initial !!!"
        '                MsgBox(msg, MsgBoxStyle.Critical, "Analyse non linaire: module Flambement")
        '                structure_OK = False : Exit Sub
        '            End If
        '            IterPdeltaTol(i) = 0
        '            Call Sauvegarde_charge_initiale(i, ForPN1, ForP1, CpleP1, ForL11, ForL12) 'comme son nom l'indique
        '            Do
        '                IterPdeltaTol(i) = IterPdeltaTol(i) + 1
        '                '--> incrmentation de la charge
        '                Call Increment_charge(i, IterPdeltaTol(i), ForPN1, ForP1, CpleP1, ForL11, ForL12)
        '                Select Case Type_probleme
        '                    Case 1 'treillis
        '                        Call Second_Membre_Treillis(L, FN, i)
        '                    Case 2 'portique
        '                        If Def_Tranchant = True Then
        '                            'calcul du vecteur force avec prise en compte de l'effort tranchant
        '                            Call Second_Membre_Portique_avec_G(L, Rot, FN, FB, i, Sr)
        '                        Else
        '                            'calcul du vecteur force sans prise en compte de l'effort tranchant
        '                            Call Second_Membre_Portique_sans_G(L, Rot, FN, FB, i)
        '                        End If
        '                End Select
        '                Call Resol(FN, Fapp, Kg, Dp, structure_OK, i)
        '                For j = 1 To Total_noeud
        '                    X_noe(j) = X_noe1(j) + Dp(1, j) : Y_noe(j) = Y_noe1(j) + Dp(2, j)
        '                Next
        '                '--> Calcul du dterminant de la matrice de rigidit de la structure dforme
        '                Call Matrice_Rigidite_2D(Kg, L, Rot, kg0, Sr)
        '                Call Appui_elastique(Kg)
        '                Call C_Limit_Kg(Kg, Fapp, structure_OK) : If structure_OK = False Then Exit Sub
        '                For j = 1 To Total_noeud * 3
        '                    If Abs(Kg(j, j)) < 0.000001 Then Kg(j, j) = 1
        '                    'Dim dd As Double
        '                    'If j = 15 Then dd = Abs(Mat12(j, j))
        '                Next
        '                Call Determinant1(3 * Total_noeud, Kg, 0.0000000000001, det1)
        '                PdeltaTol(i) = det0 / det1
        '            Loop Until (IterPdeltaTol(i) = MaxIter Or PdeltaTol(i) < MaxPdeltaTol)
        '        Next
        '        Erase FN, FB, Dp, Sr, Fapp, ForPN1, ForP1, CpleP1, ForL11, ForL12, X_noe1, Y_noe1

        '    End Sub

        '    Private Sub Determinant(ByVal n3 As Integer, ByVal akg(,) As Double, ByRef det1 As Double)
        '        Dim nm3, i, j, k, ip1 As Integer
        '        'phase 1: triangularisation de la matrice
        '        nm3 = n3 - 1
        '        det1 = 1
        '        ''provisoire
        '        'For i = 1 To 3 * Total_noeud
        '        '    For j = 1 To 3 * Total_noeud
        '        '        If Abs(akg(i, j)) < 0.0001 Then akg(i, j) = 0
        '        '    Next
        '        'Next
        '        For i = 1 To nm3
        '            'test si terme diagonal non nul
        '            If Abs(akg(i, i)) < 0.00000001 Then
        '                'Stop
        '                'Exit Sub
        '                akg(i, i) = 1
        '            End If
        '            det1 = det1 * akg(i, i)
        '            'calcul des termes sur ligne j
        '            ip1 = i + 1
        '            For j = ip1 To n3
        '                'boucle sur les termes de la ligne j
        '                For k = ip1 To n3
        '                    akg(j, k) = akg(j, k) - (akg(j, i) / akg(i, i)) * akg(i, k)
        '                Next
        '                akg(j, i) = 0
        '            Next
        '        Next
        '        Erase akg
        '    End Sub

        '    Private Sub Determinant1(ByVal n As Integer, ByVal a(,) As Double, ByVal eps As Double, ByRef d0 As Double)
        '        'The subroutine TSRGT applies to input real square matrix A(n,n) the upper
        '        'triangularization algorithm of Gauss method with full pivoting and keeps
        '        'trace of successive transformations done in integer vectors KP and LP.
        '        '-----------------------------------------------------------------------------
        '        '  Input parameters:
        '        '  eps        precision (real*8)
        '        '  n          size of A matrix (integer)
        '        '  A          pointer to input real square matrix (real*8)
        '        '  Output parameters:
        '        '  it         flag=1 if A matrix ok, =0 if A matrix is singular (integer)
        '        '  C          pointer to table storing main diagonal elements and supra-
        '        '             diagonal elements of upper triangular matrix and the multi-
        '        '             plying coefficients used during triangularization process
        '        '  KP         table storing informations concerning the column exchanges
        '        '             during process (integer)
        '        '  LP         table storing informations concerning the line exchanges
        '        '             during process (integer)
        '        '-----------------------------------------------------------------------------
        '        'The table C is first initialized to A matrix, then receives at each step k
        '        'of the triangularization process, usefull elements of A matrix at step k for
        '        'k=1,2,...n.
        '        'The variables po(real*8), lo and ko(integer) store respectively pivot at step k,
        '        'its line number and its column number.
        '        '------------------------------------------------------------------------------
        '        '1000:   'Subroutine TSRGT(eps, n, A, it, C, Kp, Lp)
        '        Dim C(n, n), po, t0 As Double
        '        Dim Kp(n), Lp(n), it, k, lo, ko As Integer
        '        Dim i, j As Integer
        '        ' set C to A
        '        For i = 1 To n
        '            For j = 1 To n
        '                C(i, j) = a(i, j)
        '            Next j
        '        Next i
        '        it = 1 : k = 1
        '1010:   po = C(k, k) : lo = k : ko = k
        '        For i = k To n
        '            For j = k To n
        '                If Abs(C(i, j)) > Abs(po) Then
        '                    po = C(i, j) : lo = i : ko = j
        '                End If
        '            Next j
        '        Next i
        '        Lp(k) = lo : Kp(k) = ko
        '        If Abs(po) < eps Then
        '            it = 0
        '        Else
        '            If lo <> k Then
        '                For j = k To n
        '                    t0 = C(k, j) : C(k, j) = C(lo, j) : C(lo, j) = t0
        '                Next j
        '            End If
        '            If ko <> k Then
        '                For i = 1 To n
        '                    t0 = C(i, k) : C(i, k) = C(i, ko) : C(i, ko) = t0
        '                Next i
        '            End If
        '            For i = k + 1 To n
        '                C(i, k) = C(i, k) / po
        '                For j = k + 1 To n
        '                    C(i, j) = C(i, j) - C(i, k) * C(k, j)
        '                Next j
        '            Next i
        '            k = k + 1
        '        End If
        '        If it = 1 And k < n Then GoTo 1010
        '        If it = 1 And Abs(C(n, n)) < eps Then it = 0
        '        'Return 'TSRGT

        '        'The function DMGT returns the determinant of a real square matrix
        '        'A(n,n) by Gauss method with full pivoting.
        '        '----------------------------------------------------------------------------
        '        '  Input parameters:
        '        '  eps        precision (real*8)
        '        '  n          size of A matrix (integer)
        '        '  A          pointer to input real square matrix
        '        '  Output parameters:
        '        '  None
        '        '-----------------------------------------------------------------------------
        '        'The procedure TSRGT is used to reduce A matrix to an upper triangular matrix.
        '        'Output variables are it(integer), C(n,n), Kp(n) and Lp(n).
        '        'If it=0, matrix A is singular, if it=1, matrix A is regular. Table C contains
        '        'at location i,j (j>=i) the corresponding element of the upper triangular matrix.
        '        'Tables Lp and Kp contain informations relative to exchanges of line or column
        '        'that occured during the process. For instance, the element number k of Lp is
        '        'an integer <> k if an exchange of line has been made at step k (k=1,2,...,n).
        '        'The number of exchanges of lines and columns is stored in integer L. the
        '        'determinant of A matrix is stored in d0 (real*8).
        '        '-----------------------------------------------------------------------------
        '2000:   'd0=DMGT(eps, n, A)

        '        ' gosub 1000  'call TSRGT(eps,n,A,it,C,Kp,Lp)
        '        Dim l As Integer
        '        If it = 0 Then
        '            d0 = 0.0#    'matrix singular, det=0
        '        Else       'matrix regular, det<>0
        '            d0 = 1.0#
        '            For k = 1 To n
        '                d0 = d0 * C(k, k)
        '            Next k
        '            l = 0
        '            For k = 1 To n - 1
        '                If Lp(k) <> k Then l = l + 1
        '                If Kp(k) <> k Then l = l + 1
        '            Next k
        '            If l Mod 2 <> 0 Then d0 = -d0 'l is odd
        '        End If
        '        'Return

        '        'End of file deter.bas

        '    End Sub

        '    Private Sub Sauvegarde_charge_initiale(ByVal N_comb As Integer, ByRef ForPN1(,,) As Double, ByRef ForP1(,,,) As Double, _
        '                                        ByRef CpleP1(,,) As Double, ByRef ForL11(,,,) As Double, ByRef ForL12(,,,) As Double)
        '        Dim i, j As Integer
        '        Dim msg As String
        '        i = Total_cas_de_charge(1) + Total_cas_de_charge(2)
        '        If Total_ForP(1, j, N_comb) > Total_ForP(2, j, N_comb) Then
        '            j = Total_ForP(1, j, N_comb)
        '        Else
        '            j = Total_ForP(2, j, N_comb)
        '        End If
        '        ReDim ForPN1(2, Total_noeud, i), ForP1(2, Total_element, j, i)
        '        ReDim CpleP1(Total_element, Total_CpleP(j, N_comb), i)
        '        If Total_ForL(1, j, N_comb) > Total_ForL(2, j, N_comb) Then
        '            j = Total_ForL(1, j, N_comb)
        '        Else
        '            j = Total_ForL(2, j, N_comb)
        '        End If
        '        ReDim ForL11(2, Total_element, j, i), ForL12(2, Total_element, j, i)

        '        'forces nodales: elles s'ajoutent directement au vecteur force
        '        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
        '            ForPN1(1, j, N_comb) = ForPN(1, j, N_comb)
        '            ForPN1(2, j, N_comb) = ForPN(2, j, N_comb)
        '        Next
        '        'forces ponctuelles sur lment
        '        For j = 1 To Total_element
        '            'force //  X local (parallle  la barre)
        '            For i = 1 To Total_ForP(1, j, N_comb)
        '                ForP1(1, j, i, N_comb) = ForP(1, j, i, N_comb)
        '            Next
        '            'force //  Y local (perpendiculaire  la barre)
        '            For i = 1 To Total_ForP(2, j, N_comb)
        '                ForP1(2, j, i, N_comb) = ForP(2, j, i, N_comb)
        '            Next
        '        Next
        '        'Couples ponctuels sur lment
        '        For j = 1 To Total_element
        '            For i = 1 To Total_CpleP(j, N_comb)
        '                CpleP1(j, i, N_comb) = CpleP(j, i, N_comb)
        '            Next
        '        Next
        '        'forces rparties sur lment
        '        For j = 1 To Total_element
        '            'force //  X local (parallle  la barre)
        '            For i = 1 To Total_ForL(1, j, N_comb)
        '                ForL11(1, j, i, N_comb) = ForL1(1, j, i, N_comb)
        '                ForL12(1, j, i, N_comb) = ForL2(1, j, i, N_comb)
        '            Next
        '            'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        '            For i = 1 To Total_ForL(2, j, N_comb)
        '                If a_ForL(2, j, i, N_comb) <> 0 Then 'And b_ForL(2, j, i, N_comb) <> L
        '                    msg = "Calcul des ractions provoques par forces rparties sur lment:" & vbCrLf & _
        '                        "La force doit s'appliquer sur l'ensemble de la longueur de l'lment." & vbCrLf & _
        '                        "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
        '                        "de la barre sur le noeud."
        '                    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Analyse non linaire: sauvegarde charges")
        '                Else
        '                    ForL11(2, j, i, N_comb) = ForL1(2, j, i, N_comb)
        '                    ForL12(2, j, i, N_comb) = ForL2(2, j, i, N_comb)
        '                End If
        '            Next
        '        Next

        '        'couples rparties sur lment
        '        For j = 1 To Total_element
        '            If CpleL1(j, N_comb) <> 0 And CpleL1(j, N_comb) <> 0 Then
        '                msg = "Calcul des ractions suite  sollicitation par couples rparties sur lment:" & vbCrLf & _
        '                             "Non pris en charge dans cette version logicielle." & vbCrLf & _
        '                             "Ces ractions n'ont pas t calcules et n'ont pas t intgres  la raction" & vbCrLf & _
        '                               "de la barre sur le noeud."
        '                MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Analyse non linaire: sauvegarde charges")
        '            End If
        '        Next

        '    End Sub

        '    Private Sub Increment_charge(ByVal N_comb As Integer, ByVal iter As Integer, ByVal ForPN1(,,) As Double, _
        '                                ByVal ForP1(,,,) As Double, ByVal CpleP1(,,) As Double, ByVal ForL11(,,,) As Double, _
        '                                ByVal ForL12(,,,) As Double)

        '        Dim i, j As Integer
        '        'forces nodales: elles s'ajoutent directement au vecteur force
        '        For j = 1 To Total_noeud      'balayage de l'ensemble des noeuds de la structure
        '            ForPN(1, j, N_comb) = ForPN1(1, j, N_comb) + iter * ForPN1(1, j, N_comb)
        '            ForPN(2, j, N_comb) = ForPN1(2, j, N_comb) + iter * ForPN1(2, j, N_comb)
        '        Next
        '        For j = 1 To Total_element
        '            'forces ponctuelles sur lment
        '            'force //  X local (parallle  la barre)
        '            For i = 1 To Total_ForP(1, j, N_comb)
        '                ForP(1, j, i, N_comb) = ForP1(1, j, i, N_comb) + iter * ForP1(1, j, i, N_comb)
        '            Next
        '            'force //  Y local (perpendiculaire  la barre)
        '            For i = 1 To Total_ForP(2, j, N_comb)
        '                ForP(2, j, i, N_comb) = ForP1(2, j, i, N_comb) + iter * ForP1(2, j, i, N_comb)
        '            Next
        '            'Couples ponctuels sur lment
        '            For i = 1 To Total_CpleP(j, N_comb)
        '                CpleP(j, i, N_comb) = CpleP1(j, i, N_comb) + iter * CpleP1(j, i, N_comb)
        '            Next
        '            'forces rparties sur lment
        '            'force //  X local (parallle  la barre)
        '            For i = 1 To Total_ForL(1, j, N_comb)
        '                ForL1(1, j, i, N_comb) = ForL11(1, j, i, N_comb) + iter * ForL11(1, j, i, N_comb)
        '                ForL2(1, j, i, N_comb) = ForL12(1, j, i, N_comb) + iter * ForL12(1, j, i, N_comb)
        '            Next
        '            'force //  Y local (perpendiculaire  la barre)  force rpartie suivant Y local
        '            For i = 1 To Total_ForL(2, j, N_comb)
        '                ForL1(2, j, i, N_comb) = ForL11(2, j, i, N_comb) + iter * ForL11(2, j, i, N_comb)
        '                ForL2(2, j, i, N_comb) = ForL12(2, j, i, N_comb) + iter * ForL12(2, j, i, N_comb)
        '            Next
        '        Next
        '    End Sub

    End Sub
End Module

  