Imports System.ComponentModel
Imports System.Drawing
'Imports System.data
Imports System.Drawing.Printing
Imports System.Runtime.InteropServices
'Imports System.Threading
Imports System.Text

Public Class frmEdit
    ' DECLARATIONS
    Dim snom_fichier As System.IO.DirectoryInfo
    Private schemin_fichier As String
    Private document_modifie As Boolean
    Dim oStyle_selection As Style_selection
    Dim sFontselectionnee As Object
    Dim sTailleselectionnee As Object
    Dim Tailleselectionnee_toolstrip As Object
    Private strDocTitre As String
    Public Event ExitApplication As System.EventHandler
    Private m_nFirstCharOnPage As Integer
    Private ipage As Integer

    ' EVENEMENTS
#Region "INITIALISATION ET FERMETURE FORMULAIRE"

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        oStyle_selection = New Style_selection

        ipage = 1
        document_modifie = False
        schemin_fichier = ""

        initialiser_menu_fichiers_recents()
        initialiser_a_partir_options()
    End Sub
    Public Sub Affichage_frmEdit(ByVal fichier As String)
        Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'rpertoire dans lequel se trouve le logiciel Structure
        Try
            RichTextBox1.LoadFile(SousDossier1 & fichier, RichTextBoxStreamType.RichText)
        Catch ex As Exception
            Dim msg As String
            msg = "Problme d'affichage" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
        Me.Visible = True
    End Sub

#End Region

#Region "MENU FICHIER"

    Private Sub OuvrirToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OuvrirToolStripMenuItem.Click
        ouvrir()
    End Sub

    Private Sub EnregistrerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnregistrerToolStripMenuItem.Click
        enregistrer()
    End Sub

    Private Sub EnregistrersousToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnregistrersousToolStripMenuItem.Click
        enregistrer_sous()
    End Sub

    Private Sub AperuavantimpressionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AperuavantimpressionToolStripMenuItem.Click
        apercu_avant_impression()
    End Sub

    Private Sub ImprimerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImprimerToolStripMenuItem.Click
        imprimer()
    End Sub

    Private Sub QuitterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QuitterToolStripMenuItem.Click
        quitter()
    End Sub

#End Region

#Region "MENU EDITION"

    Private Sub AnnulerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnnulerToolStripMenuItem.Click
        annuler()
    End Sub

    Private Sub RtablirToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RtablirToolStripMenuItem.Click
        retablir()
    End Sub

    Private Sub CouperToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CouperToolStripMenuItem.Click
        couper()
    End Sub

    Private Sub CopierToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopierToolStripMenuItem.Click
        copier()
    End Sub

    Private Sub CollerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CollerToolStripMenuItem.Click
        coller()
    End Sub
    Private Sub ImageToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImageToolStripMenuItem1.Click
        inserer_image()
    End Sub
    '
#End Region

#Region "MENU FORMAT"

    Private Sub PoliceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PoliceToolStripMenuItem.Click
        police()
    End Sub

    Private Sub AGaucheToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AGaucheToolStripMenuItem.Click
        aligner_gauche()
    End Sub

    Private Sub AuCentreToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AuCentreToolStripMenuItem.Click
        aligner_centre()
    End Sub

    Private Sub DroiteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DroiteToolStripMenuItem.Click
        aligner_droite()
    End Sub

    Private Sub StyleDePuceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StyleDePuceToolStripMenuItem.Click
        mettre_puces()
    End Sub

#End Region

#Region "TOOLSTRIP"

    Private Sub OuvrirToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OuvrirToolStripButton.Click
        ouvrir()
    End Sub

    Private Sub EnregistrerToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnregistrerToolStripButton.Click
        enregistrer()
    End Sub

    Private Sub CouperToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CouperToolStripButton.Click
        couper()
    End Sub

    Private Sub CopierToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopierToolStripButton.Click
        copier()
    End Sub

    Private Sub CollerToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CollerToolStripButton.Click
        coller()
    End Sub

    Private Sub AnnulerStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnnulerStripButton.Click
        annuler()
    End Sub

    Private Sub retablirStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles retablirStripButton.Click
        retablir()
    End Sub

    Private Sub GrasStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GrasStripButton.Click
        gras()
    End Sub

    Private Sub ItalicStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItalicStripButton.Click
        italic()
    End Sub

    Private Sub soulignerStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles soulignerStripButton.Click
        souligner()
    End Sub

    Private Sub barrerStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles barrerStripButton.Click
        barrer()
    End Sub

    Private Sub cboFontFamily_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboFontFamily.SelectedIndexChanged

        Dim newfontselectionnee As System.Drawing.FontFamily

        Try

            If (cboFontFamily.Text <> "" Or IsNumeric(cboFontFamily.Text) = False) Then
                recuperer_style_selection()

                newfontselectionnee = New System.Drawing.FontFamily(cboFontFamily.Text)

                sFontselectionnee = cboFontFamily.Items.Item(cboFontFamily.SelectedIndex)
                oStyle_selection.police = newfontselectionnee

                recreer_style_selection()
                mettre_a_jour_barre_outil()
                RichTextBox1.Focus()
            Else
                recuperer_style_selection()

                recreer_style_selection()
                mettre_a_jour_barre_outil()
                RichTextBox1.Focus()
            End If


        Catch ex As Exception

        End Try
    End Sub

    Private Sub couleurfondStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles couleurfondStripButton.Click
        police()
    End Sub

    Private Sub cboTaille_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboTaille.SelectedIndexChanged
        Try
            recuperer_style_selection()

            oStyle_selection.taille = CInt(cboTaille.Items.Item(cboTaille.SelectedIndex))
            recreer_style_selection()
            mettre_a_jour_barre_outil()
            RichTextBox1.Focus()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub cboTaille_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboTaille.TextChanged
        Try

            If (cboTaille.Text = "" Or IsNumeric(cboTaille.Text) = False) Then
                RichTextBox1.Undo()
                Exit Sub
            Else
                recuperer_style_selection()
                oStyle_selection.taille = CInt(cboTaille.Text)
                recreer_style_selection()
                mettre_a_jour_barre_outil()
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub couleurtexteStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles couleurtexteStripButton.Click
        couleur_texte()
    End Sub

    Private Sub couleurfondToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles couleurfondToolStripButton.Click
        couleur_arriereplan_texte()
    End Sub

    Private Sub retraitStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles retraitStripButton.Click
        indenter()
    End Sub

    Private Sub retirerretraitStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles retirerretraitStripButton.Click
        deindenter()
    End Sub

    Private Sub AlignementGaucheToolstripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlignementGaucheToolstripButton.Click
        aligner_gauche()
    End Sub

    Private Sub centrerToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles centrerToolStripButton1.Click
        aligner_centre()
    End Sub

    Private Sub AlignementdroitToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlignementdroitToolStripButton.Click
        aligner_droite()
    End Sub

    Private Sub pucesStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pucesStripButton.Click
        mettre_puces()
    End Sub

#End Region

#Region "RICHTEXTBOX1"

    Private Sub RichTextBox1_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkClickedEventArgs) Handles RichTextBox1.LinkClicked
        System.Diagnostics.Process.Start(e.LinkText)
    End Sub

    Private Sub RichTextBox1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RichTextBox1.SelectionChanged
        recuperer_style_selection()
        mettre_a_jour_barre_outil()
    End Sub

#End Region

    ' AFFICHAGE

#Region "DOCUMENT"
    Public Sub initialiser_a_partir_options()
        Dim oFont As Integer
        'Dim posrecherchefont, posrechercheTaille As Integer



        Try
            If cboFontFamily.Items.Count > 0 Then
                cboFontFamily.Items.Clear()
            End If


            For oFont = 0 To System.Drawing.FontFamily.Families.Length - 1
                cboFontFamily.Items.Add(System.Drawing.FontFamily.Families(oFont).Name)

            Next

            If cboFontFamily.Items.Count = 0 Then
                ' liste vide
            Else


                'If My.Settings.option_police = "" Then
                '    sFontselectionnee = "Times New Roman"
                '    posrecherchefont = cboFontFamily.FindString(sFontselectionnee.ToString)

                '    If posrecherchefont = -1 Then
                '        ' font non trouve
                '    Else
                '        cboFontFamily.SelectedIndex = posrecherchefont
                '    End If

                'Else

                '    sFontselectionnee = My.Settings.option_police
                '    posrecherchefont = cboFontFamily.FindString(sFontselectionnee.ToString)

                '    If posrecherchefont = -1 Then
                '        ' font non trouve
                '    Else
                '        cboFontFamily.SelectedIndex = posrecherchefont
                '    End If

                'End If

            End If
        Catch ex As Exception

        End Try

        Try
            'If My.Settings.option_color_texte = Nothing Then

            'Else
            '    RichTextBox1.SelectionColor = My.Settings.option_color_texte

            'End If
        Catch ex As Exception

        End Try

        Try

            'If My.Settings.option_taille_police = Nothing Then
            '    Tailleselectionnee_toolstrip = 11
            '    posrechercheTaille = cboTaille.FindString(Tailleselectionnee_toolstrip.ToString)

            '    If posrechercheTaille = -1 Then

            '    Else
            '        cboTaille.SelectedIndex = posrechercheTaille
            '    End If
            'Else
            '    Tailleselectionnee_toolstrip = My.Settings.option_taille_police
            '    posrechercheTaille = cboTaille.FindString(Tailleselectionnee_toolstrip.ToString)
            '    If posrechercheTaille = -1 Then

            '    Else
            '        cboTaille.SelectedIndex = posrechercheTaille
            '    End If
            'End If
        Catch ex As Exception

        End Try

        Try
            'If My.Settings.option_transparence = Nothing Then

            'Else
            '    Me.Opacity = (My.Settings.option_transparence * 0.1)
            'End If
        Catch ex As Exception

        End Try

        Try
            'If My.Settings.option_rendermode = Nothing Then

            'Else
            '    Select Case True
            '        Case My.Settings.option_rendermode = ToolStripRenderMode.ManagerRenderMode
            '            Me.ToolStrip1.BackgroundImage = My.Resources.res_tool__1
            '            SetRenderer(Me, ToolStripRenderMode.Professional)

            '        Case My.Settings.option_rendermode = ToolStripRenderMode.Professional
            '            Me.ToolStrip1.BackgroundImage = Nothing
            '            SetRenderer(Me, ToolStripRenderMode.Professional)

            '        Case My.Settings.option_rendermode = ToolStripRenderMode.System
            '            Me.BackgroundImage = Nothing
            '            SetRenderer(Me, ToolStripRenderMode.System)


            '    End Select
            'End If
        Catch ex As Exception

        End Try

    End Sub
    Private Sub SetRenderer(ByVal ctl As Control, ByVal renderMode As ToolStripRenderMode)

        For Each control As Control In ctl.Controls
            Dim prop As System.ComponentModel.PropertyDescriptor = System.ComponentModel.TypeDescriptor.GetProperties(control)("RenderMode")
            If Not (prop Is Nothing) Then
                prop.SetValue(control, renderMode)
            End If
            If ctl.Controls.Count > 0 Then
                SetRenderer(control, renderMode)
            End If

        Next

    End Sub
    Public Sub initialiser_menu_fichiers_recents()

        'If (My.Settings.fichier_recent_1 <> "") Then
        '    Dim menuFichierrecents1 As System.Windows.Forms.ToolStripMenuItem
        '    Dim snom_temp_fichier As New System.IO.DirectoryInfo(My.Settings.fichier_recent_1)
        '    menuFichierrecents1 = New System.Windows.Forms.ToolStripMenuItem

        '    FichiersRcentsToolStripMenuItem.DropDownItems.Add(menuFichierrecents1)

        '    menuFichierrecents1.Name = "menuFichierrecents1"
        '    menuFichierrecents1.Size = New System.Drawing.Size(152, 22)
        '    menuFichierrecents1.Text = snom_temp_fichier.Name
        '    AddHandler menuFichierrecents1.Click, AddressOf gerer_menu_fichiers_recents
        'End If

        'If (My.Settings.fichier_recent_2 <> "") Then

        '    Dim menuFichierrecents2 As System.Windows.Forms.ToolStripMenuItem
        '    Dim snom_temp_fichier As New System.IO.DirectoryInfo(My.Settings.fichier_recent_2)
        '    menuFichierrecents2 = New System.Windows.Forms.ToolStripMenuItem

        '    FichiersRcentsToolStripMenuItem.DropDownItems.Add(menuFichierrecents2)

        '    menuFichierrecents2.Name = "menuFichierrecents2"
        '    menuFichierrecents2.Size = New System.Drawing.Size(152, 22)
        '    menuFichierrecents2.Text = snom_temp_fichier.Name
        '    AddHandler menuFichierrecents2.Click, AddressOf gerer_menu_fichiers_recents
        'End If
        'If (My.Settings.fichier_recent_3 <> "") Then
        '    Dim menuFichierrecents3 As System.Windows.Forms.ToolStripMenuItem
        '    Dim snom_temp_fichier As New System.IO.DirectoryInfo(My.Settings.fichier_recent_3)
        '    menuFichierrecents3 = New System.Windows.Forms.ToolStripMenuItem

        '    FichiersRcentsToolStripMenuItem.DropDownItems.Add(menuFichierrecents3)

        '    menuFichierrecents3.Name = "menuFichierrecents2"
        '    menuFichierrecents3.Size = New System.Drawing.Size(152, 22)
        '    menuFichierrecents3.Text = snom_temp_fichier.Name
        '    AddHandler menuFichierrecents3.Click, AddressOf gerer_menu_fichiers_recents
        'End If

    End Sub
    'Private Sub gerer_menu_fichiers_recents(ByVal sender As System.Object, _
    '   ByVal e As System.EventArgs)

    '    Try
    '        Select Case True
    '            Case sender.name Is "menuFichierrecents1"
    '                ouvrir_recent(My.Settings.fichier_recent_1)
    '            Case sender.name Is "menuFichierrecents2"
    '                ouvrir_recent(My.Settings.fichier_recent_2)
    '            Case sender.name Is "menuFichierrecents3"
    '                ouvrir_recent(My.Settings.fichier_recent_3)
    '            Case Else

    '                MessageBox.Show("un problme empche l'execution de la commande,la commande du menu n'est pas reconnue")

    '        End Select
    '    Catch ex As Exception

    '    End Try


    'End Sub
    'Public Sub enregistrer_settings_fichiers_recents()
    '    If schemin_fichier <> "" Then
    '        If (My.Settings.fichier_recent_1 = "") Then
    '            My.Settings.fichier_recent_1 = schemin_fichier
    '        ElseIf (My.Settings.fichier_recent_2 = "") Then
    '            My.Settings.fichier_recent_2 = schemin_fichier
    '        ElseIf (My.Settings.fichier_recent_3 = "") Then
    '            My.Settings.fichier_recent_3 = schemin_fichier
    '        Else
    '            My.Settings.fichier_recent_3 = My.Settings.fichier_recent_2
    '            My.Settings.fichier_recent_2 = My.Settings.fichier_recent_1
    '            My.Settings.fichier_recent_1 = schemin_fichier
    '        End If

    '        My.Settings.Save()

    '    End If
    'End Sub
    Public Sub ouvrir_recent(ByRef setting_recu As String)
        Try

            If My.Computer.FileSystem.FileExists(setting_recu) Then
                snom_fichier = New System.IO.DirectoryInfo(setting_recu)

                If snom_fichier.Extension = ".txt" Then
                    RichTextBox1.Text = My.Computer.FileSystem.ReadAllText(setting_recu)
                    document_modifie = False
                    schemin_fichier = setting_recu
                    Me.Text = snom_fichier.Name
                ElseIf snom_fichier.Extension = ".rtf" Then
                    RichTextBox1.LoadFile(setting_recu)
                    schemin_fichier = setting_recu
                    document_modifie = False
                    Me.Text = snom_fichier.Name
                Else
                    MessageBox.Show("Ce format de fichier ne peut tre ouvert, dsol", "Attention ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

                End If

            Else
                MessageBox.Show("le fichier spcifi n'existe pas ou a t supprim, il ne peut tre ouvert, dsol", "Attention...", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub

            End If
        Catch fileException As Exception
            Throw fileException
        End Try


    End Sub
    Public Sub ouvrir()
        Dim odlg As OpenFileDialog
        odlg = New OpenFileDialog

        Try
            With odlg
                .CheckFileExists = True
                .CheckPathExists = True
                '.DefaultExt = "txt"
                .DereferenceLinks = True
                .Filter = "Document texte (*.txt)|*.txt|Document au format RTF (*.rtf)|*.rtf|Word pour Windows (*.doc)|*.doc|Tous les documents (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                .ShowHelp = False
                .ShowReadOnly = False
                .ReadOnlyChecked = False
                .Title = "Choisir un fichier  ouvrir..."
                .ValidateNames = True
                ' ----- > 
                If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                    Try
                        If My.Computer.FileSystem.FileExists(odlg.FileName) Then
                            snom_fichier = New System.IO.DirectoryInfo(odlg.FileName)

                            If snom_fichier.Extension = ".txt" Then
                                RichTextBox1.Text = My.Computer.FileSystem.ReadAllText(.FileName)
                                document_modifie = False
                                schemin_fichier = odlg.FileName
                                Me.Text = snom_fichier.Name

                            ElseIf snom_fichier.Extension = ".rtf" Then
                                RichTextBox1.LoadFile(odlg.FileName)
                                schemin_fichier = odlg.FileName
                                document_modifie = False
                                Me.Text = snom_fichier.Name

                            Else
                                MessageBox.Show("Ce format de fichier ne peut tre ouvert, dsol", "Attention ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            End If
                        End If
                    Catch fileException As Exception
                        Throw fileException
                    End Try
                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
        End Try
    End Sub

    Public Sub enregistrer()

        If (schemin_fichier <> "") Then
            Try
                If My.Computer.FileSystem.FileExists(schemin_fichier) Then
                    snom_fichier = New System.IO.DirectoryInfo(schemin_fichier)
                    ' If snom_fichier.Exists Then

                    Select Case snom_fichier.Extension
                        Case ".txt"
                            Try
                                My.Computer.FileSystem.WriteAllText(schemin_fichier, RichTextBox1.Text, False)
                                document_modifie = False
                                Me.Text = snom_fichier.Name
                            Catch ex As Exception
                                MsgBox(ex.Message, MsgBoxStyle.Exclamation, Me.Text)
                            End Try
                        Case ".rtf"
                            Try
                                RichTextBox1.SaveFile(schemin_fichier)
                                document_modifie = False
                                Me.Text = snom_fichier.Name
                            Catch ex As Exception
                                MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
                            End Try

                        Case Else
                            MessageBox.Show("format Word non reconnu")
                    End Select
                Else
                    MessageBox.Show("le fichier n'existe pas ou a t supprim, slectionner Enregistrer sous pour resauvegarder le fichier")

                End If
                ' End If
            Catch ex As Exception
                Throw ex
            End Try
        Else
            enregistrer_sous()


        End If


    End Sub
    Public Sub enregistrer_sous()

        Dim sdlg As SaveFileDialog
        Dim sext As String

        sdlg = New SaveFileDialog
        sext = ""

        Try

            With sdlg

                .AddExtension = True
                .CheckPathExists = True
                .CreatePrompt = False
                .OverwritePrompt = True
                .ValidateNames = True
                .CheckFileExists = False
                .CheckPathExists = False
                .DereferenceLinks = True
                .Filter = "Document texte (*.txt)|*.txt|Document au format RTF (*.rtf)|*.rtf|Tous les documents (*.*)|*.*"
                .RestoreDirectory = False
                .ShowHelp = False
                .Title = "Sauvergarder sous..."
                .ValidateNames = True
                ' ---- >
                If .ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    Try
                        ' If My.Computer.FileSystem.FileExists(sdlg.FileName) Then
                        snom_fichier = New System.IO.DirectoryInfo(sdlg.FileName)

                        Select Case snom_fichier.Extension
                            Case ".txt"
                                Try
                                    My.Computer.FileSystem.WriteAllText(.FileName, RichTextBox1.Text, False)
                                    schemin_fichier = sdlg.FileName
                                    Me.Text = snom_fichier.Name
                                    document_modifie = False
                                Catch ex As Exception
                                    MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
                                End Try
                            Case ".rtf"
                                Try
                                    RichTextBox1.SaveFile(sdlg.FileName)
                                    schemin_fichier = sdlg.FileName
                                    Me.Text = snom_fichier.Name
                                    document_modifie = False
                                Catch ex As Exception
                                    MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
                                End Try

                            Case Else
                                MessageBox.Show("format Word non reconnu", "Attention ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End Select
                        'End If
                    Catch fileException As Exception
                        Throw fileException
                    End Try
                End If

            End With
        Catch ex As Exception

            MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)

        End Try

    End Sub
    Public Sub quitter()
        Me.Dispose()
        Me.Finalize()
        Exit Sub
    End Sub

#End Region

#Region "STYLE_SELECTION POLICE"
    Public Sub recuperer_style_selection()

        Dim currentFont As System.Drawing.Font

        Try
            'If RichTextBox1.SelectionFont Is Nothing Then

            'Else
            currentFont = RichTextBox1.SelectionFont

            oStyle_selection.police = currentFont.FontFamily
            oStyle_selection.taille = currentFont.Size
            oStyle_selection.gras = currentFont.Bold
            oStyle_selection.italic = currentFont.Italic
            oStyle_selection.souligne = currentFont.Underline
            oStyle_selection.barre = currentFont.Strikeout
            oStyle_selection.couleur = RichTextBox1.SelectionColor
            oStyle_selection.couleur_fond = RichTextBox1.SelectionBackColor

            ' End If
        Catch ex As Exception

        End Try


    End Sub

    Public Sub recreer_style_selection()
        Dim nouveaustyle As System.Drawing.FontStyle
        Dim NewFont As System.Drawing.Font

        Try
            If (oStyle_selection.gras = True) Then
                nouveaustyle = CType(FontStyle.Bold, FontStyle)
            End If
            If (oStyle_selection.italic = True) Then
                nouveaustyle = CType(nouveaustyle + CType(FontStyle.Italic, FontStyle), FontStyle)
            End If
            If (oStyle_selection.souligne = True) Then
                nouveaustyle = CType(nouveaustyle + CType(FontStyle.Underline, FontStyle), FontStyle)

            End If
            If (oStyle_selection.barre = True) Then
                nouveaustyle = CType(nouveaustyle + CType(FontStyle.Strikeout, FontStyle), FontStyle)

            End If

            NewFont = New System.Drawing.Font(oStyle_selection.police, oStyle_selection.taille, nouveaustyle)
            RichTextBox1.SelectionFont = NewFont
            RichTextBox1.SelectionBackColor = oStyle_selection.couleur_fond
            RichTextBox1.SelectionColor = oStyle_selection.couleur
        Catch ex As Exception

        End Try

    End Sub

    Public Sub mettre_a_jour_barre_outil()
        Dim posrecherche, postaille As Integer

        Try

            sFontselectionnee = oStyle_selection.police.Name
            posrecherche = cboFontFamily.FindString(sFontselectionnee.ToString)
            If posrecherche = -1 Then

            Else
                cboFontFamily.SelectedIndex = posrecherche
            End If

        Catch ex As Exception

        End Try
        Try
            sTailleselectionnee = oStyle_selection.taille
            postaille = cboTaille.FindString(sTailleselectionnee.ToString)
            If postaille <> -1 Then
                cboTaille.SelectedIndex = postaille
            Else
                cboTaille.Text = oStyle_selection.taille.ToString
            End If

        Catch ex As Exception

        End Try
        Try
            If (oStyle_selection.gras = True) Then
                GrasStripButton.Checked = True
            Else
                GrasStripButton.Checked = False
            End If
            If (oStyle_selection.italic = True) Then
                ItalicStripButton.Checked = True
            Else
                ItalicStripButton.Checked = False
            End If
            If (oStyle_selection.souligne = True) Then
                soulignerStripButton.Checked = True
            Else
                soulignerStripButton.Checked = False
            End If
            If (oStyle_selection.barre = True) Then
                barrerStripButton.Checked = True
            Else
                barrerStripButton.Checked = False
            End If
        Catch ex As Exception

        End Try


    End Sub
#End Region

#Region "METHODES DE MISE EN FORME"
    Public Sub annuler()
        Try
            RichTextBox1.Undo()
        Catch ex As Exception

        End Try

    End Sub
    Public Sub retablir()
        Try
            RichTextBox1.Redo()
        Catch ex As Exception

        End Try

    End Sub
    Public Sub couper()
        Try
            If (RichTextBox1.SelectionLength > 0) Then
                RichTextBox1.Cut()
            End If
        Catch ex As Exception

        End Try
    End Sub
    Public Sub copier()
        Try
            RichTextBox1.Copy()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub coller()
        Try
            RichTextBox1.Paste()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub selectionner_tout()
        Try
            RichTextBox1.SelectAll()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub gras()
        Try
            recuperer_style_selection()

            If (oStyle_selection.gras = True) Then
                oStyle_selection.gras = False
            Else
                oStyle_selection.gras = True
            End If

            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub italic()
        Try
            recuperer_style_selection()

            If (oStyle_selection.italic = True) Then
                oStyle_selection.italic = False
            Else
                oStyle_selection.italic = True
            End If

            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub souligner()
        Try
            recuperer_style_selection()

            If (oStyle_selection.souligne = True) Then
                oStyle_selection.souligne = False
            Else
                oStyle_selection.souligne = True
            End If

            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub barrer()
        Try
            recuperer_style_selection()

            If (oStyle_selection.barre = True) Then
                oStyle_selection.barre = False
            Else
                oStyle_selection.barre = True
            End If
            recreer_style_selection()
            mettre_a_jour_barre_outil()

        Catch ex As Exception

        End Try
    End Sub
    Public Sub police()
        Try
            recuperer_style_selection()

            changer_police()
            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub changer_police()
        Dim fdlg As FontDialog
        fdlg = New FontDialog

        Try
            With fdlg
                .Font = fdlg.Font
                .ShowColor = True
                .ShowApply = True
                .ShowEffects = True
                .ShowHelp = False
                .Color = fdlg.Color
                .AllowScriptChange = True
                .AllowSimulations = True
                .AllowVectorFonts = True
                .AllowVerticalFonts = False
                .FixedPitchOnly = False
                .FontMustExist = True
                .MaxSize = 48
                .MinSize = 8

                If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                    oStyle_selection.police = .Font.FontFamily
                    oStyle_selection.gras = .Font.Bold
                    oStyle_selection.italic = .Font.Italic
                    oStyle_selection.souligne = .Font.Underline
                    oStyle_selection.barre = .Font.Strikeout
                    oStyle_selection.taille = .Font.SizeInPoints
                    oStyle_selection.couleur = .Color

                End If

            End With

        Catch ex As Exception

            MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)

        End Try

    End Sub
    Public Sub couleur_texte()
        Try
            recuperer_style_selection()

            coloriser_texte()
            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub coloriser_texte()
        Dim cdlg As ColorDialog
        cdlg = New ColorDialog
        Static CustomColors() As Integer = {RGB(255, 0, 0), RGB(0, 255, 0), RGB(0, 0, 255)}

        Try

            With cdlg
                .Color = cdlg.Color
                .CustomColors = CustomColors
                .AllowFullOpen = True
                .AnyColor = True
                .FullOpen = True
                .SolidColorOnly = True
                .ShowHelp = False
                ' ---- > on colore le contenu de la richtextbox
                If .ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    oStyle_selection.couleur = .Color
                    CustomColors = .CustomColors
                End If
                cdlg.Reset()
            End With

        Catch ex As Exception
            MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
        End Try
    End Sub
    Public Sub couleur_arriereplan_texte()

        Try
            recuperer_style_selection()
            coloriser_fond()
            recreer_style_selection()
            mettre_a_jour_barre_outil()
        Catch ex As Exception

        End Try

    End Sub
    Public Sub coloriser_fond()
        Dim cdlg As ColorDialog
        cdlg = New ColorDialog
        Static CustomColors() As Integer = {RGB(255, 0, 0), RGB(0, 255, 0), RGB(0, 0, 255)}

        Try

            With cdlg
                .Color = cdlg.Color
                .CustomColors = CustomColors
                .AllowFullOpen = True
                .AnyColor = True
                .FullOpen = True
                .SolidColorOnly = True
                .ShowHelp = False
                ' ---- > on colore le contenu de la richtextbox
                If .ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    oStyle_selection.couleur_fond = .Color
                    CustomColors = .CustomColors
                End If
                cdlg.Reset()
            End With

        Catch ex As Exception
            MsgBox(ex.Message & ex.StackTrace, MsgBoxStyle.Exclamation, Me.Text)
        End Try
    End Sub
    Public Sub indenter()

        Try

            RichTextBox1.SelectionIndent += 30

        Catch ex As Exception

        End Try

    End Sub
    Public Sub deindenter()

        Try
            If (RichTextBox1.SelectionIndent = 0) Then

            Else
                RichTextBox1.SelectionIndent -= 30
            End If
        Catch ex As Exception

        End Try

    End Sub
    Public Sub aligner_gauche()
        Try
            RichTextBox1.SelectionAlignment = HorizontalAlignment.Left

        Catch ex As Exception

        End Try
    End Sub
    Public Sub aligner_centre()
        Try
            RichTextBox1.SelectionAlignment = HorizontalAlignment.Center

        Catch ex As Exception

        End Try
    End Sub
    Public Sub aligner_droite()
        Try
            RichTextBox1.SelectionAlignment = HorizontalAlignment.Right

        Catch ex As Exception

        End Try
    End Sub
    Public Sub mettre_puces()
        Try
            If (pucesStripButton.Checked = True) Then
                RichTextBox1.SelectionBullet = False
                pucesStripButton.Checked = False
            Else
                RichTextBox1.SelectionBullet = True
                pucesStripButton.Checked = True
            End If
        Catch ex As Exception

        End Try

    End Sub
    Public Sub inserer_image()

        Dim odlg As OpenFileDialog


        odlg = New OpenFileDialog

        Try

            With odlg
                .Filter = "Toutes les images (*.jpg,*.jpeg, *.png,*.bmp,*.gif)|*.jpg;*.jpeg;*.png;*.bmp;*.gif|Tous les fichiers|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                .ShowHelp = False
                .ShowReadOnly = False
                .ReadOnlyChecked = False
                .Title = "Choisir une image ..."
            End With

            If odlg.ShowDialog = System.Windows.Forms.DialogResult.OK Then

                Dim image_a_inserer As Bitmap = New Bitmap(odlg.FileName)
                Clipboard.SetDataObject(image_a_inserer, False)
                RichTextBox1.Paste(DataFormats.GetFormat(DataFormats.Bitmap))
            End If

        Catch ex As Exception

        End Try

    End Sub
#End Region

#Region "RECHERCHER REMPLACER EXPRESSIONS"
    'Public Sub rechercher()


    '    Dim frmrecherche As FRechercher



    '    Dim i As Integer

    '    For i = 0 To My.Application.OpenForms.Count - 1
    '        If Me Is My.Application.OpenForms(i) Then
    '            occurence_recherche._mfenetre_demande = i
    '        End If
    '    Next

    '    Try


    '        frmrecherche = New FRechercher


    '        If Form_Frecherche.m_Forms_recherche_crees > 0 Then


    '        Else
    '            frmrecherche.Owner = Me
    '            frmrecherche.TopLevel = True
    '            Form_Frecherche.m_Forms_recherche_crees += 1
    '            frmrecherche.Show()
    '        End If


    '    Catch ex As Exception

    '    End Try
    'End Sub

#End Region

#Region "IMPRESSION"
    Public Sub apercu_avant_impression()
        Dim YPreview As New PrintPreviewDialog
        YPreview.WindowState = FormWindowState.Maximized
        YPreview.Document = PrintDocument1
        YPreview.ShowDialog()
    End Sub
    Public Sub imprimer()
        PrintDialog1.Document = PrintDocument1
        If PrintDialog1.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

#Region "structures"
    Private Structure STRUCT_RECT
        Public left As Integer
        Public top As Integer
        Public right As Integer
        Public bottom As Integer
    End Structure

    Private Structure STRUCT_CHAR_RANGE
        Public cpMin As Integer
        Public cpMax As Integer
    End Structure

    Private Structure STRUCT_FORMAT_RANGE
        Public hdc As IntPtr
        Public hdcTarget As IntPtr
        Public rc As STRUCT_RECT
        Public rcPage As STRUCT_RECT
        Public chrg As STRUCT_CHAR_RANGE
    End Structure

    Private Structure STRUCT_CHAR_FORMAT
        Public cbSize As Integer
        Public dwMask As UInt32
        Public dwEffects As UInt32
        Public yHeight As Integer
        Public yOffset As Integer
        Public crTextColor As Integer
        Public bCharSet As Byte
        Public bPitchAndFamily As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Public szFaceName As Char()
    End Structure

    Private Const WM_USER As Integer = 1024
    Private Const EM_FORMATRANGE As Integer = 1081
    Private Const EM_GETCHARFORMAT As Integer = 1082
    Private Const EM_SETCHARFORMAT As Integer = 1092
    Private SCF_SELECTION As Integer
    Private SCF_WORD As Integer
    Private SCF_ALL As Integer
    Private Const CFM_BOLD As Long = 1
    Private Const CFM_ITALIC As Long = 2
    Private Const CFM_UNDERLINE As Long = 4
    Private Const CFM_STRIKEOUT As Long = 8
    Private Const CFM_PROTECTED As Long = 16
    Private Const CFM_LINK As Long = 32
    Private Const CFM_SIZE As Long = 2147483648
    Private Const CFM_COLOR As Long = 1073741824
    Private Const CFM_FACE As Long = 536870912
    Private Const CFM_OFFSET As Long = 268435456
    Private Const CFM_CHARSET As Long = 134217728
    Private Const CFE_BOLD As Long = 1
    Private Const CFE_ITALIC As Long = 2
    Private Const CFE_UNDERLINE As Long = 4
    Private Const CFE_STRIKEOUT As Long = 8
    Private Const CFE_PROTECTED As Long = 16
    Private Const CFE_LINK As Long = 32
    Private Const CFE_AUTOCOLOR As Long = 1073741824
#End Region

    <DllImportAttribute("user32.dll")> _
           Private Shared Shadows Function SendMessage(ByVal hWnd As IntPtr, ByVal msg As Integer, ByVal wParam As Integer, ByVal lParam As IntPtr) As Integer
    End Function

    Public Function FormatRange(ByVal measureOnly As Boolean, ByVal e As PrintPageEventArgs, ByVal charFrom As Integer, ByVal charTo As Integer) As Integer
        Dim sTRUCT_CHAR_RANGE As STRUCT_CHAR_RANGE
        Dim sTRUCT_FORMAT_RANGE As STRUCT_FORMAT_RANGE
        Dim sTRUCT_RECT1 As STRUCT_RECT
        Dim sTRUCT_RECT2 As STRUCT_RECT
        Dim j2 As Integer
        'Dim rectangle As Rectangle
        sTRUCT_CHAR_RANGE.cpMin = charFrom
        sTRUCT_CHAR_RANGE.cpMax = charTo
        sTRUCT_RECT1.top = HundredthInchToTwips(e.MarginBounds.Top)
        sTRUCT_RECT1.bottom = HundredthInchToTwips(e.MarginBounds.Bottom)
        sTRUCT_RECT1.left = HundredthInchToTwips(e.MarginBounds.Left)
        sTRUCT_RECT1.right = HundredthInchToTwips(e.MarginBounds.Right)
        sTRUCT_RECT2.top = HundredthInchToTwips(e.PageBounds.Top)
        sTRUCT_RECT2.bottom = HundredthInchToTwips(e.PageBounds.Bottom)
        sTRUCT_RECT2.left = HundredthInchToTwips(e.PageBounds.Left)
        sTRUCT_RECT2.right = HundredthInchToTwips(e.PageBounds.Right)
        Dim j1 As IntPtr = e.Graphics.GetHdc()
        sTRUCT_FORMAT_RANGE.chrg = sTRUCT_CHAR_RANGE
        sTRUCT_FORMAT_RANGE.hdc = j1
        sTRUCT_FORMAT_RANGE.hdcTarget = j1
        sTRUCT_FORMAT_RANGE.rc = sTRUCT_RECT1
        sTRUCT_FORMAT_RANGE.rcPage = sTRUCT_RECT2
        If measureOnly Then
            j2 = 0
        Else
            j2 = 1
        End If
        Dim k As IntPtr = Marshal.AllocCoTaskMem(Marshal.SizeOf(sTRUCT_FORMAT_RANGE))
        Marshal.StructureToPtr(sTRUCT_FORMAT_RANGE, k, False)
        Dim i2 As Integer = SendMessage(RichTextBox1.Handle, 1081, j2, k)
        Marshal.FreeCoTaskMem(k)
        e.Graphics.ReleaseHdc(j1)
        Return i2
    End Function

    Private Function HundredthInchToTwips(ByVal n As Integer) As Integer
        Return Convert.ToInt32(n * 14.4)
    End Function

    Public Sub FormatRangeDone()
        Dim i As IntPtr = New IntPtr(0)
        SendMessage(RichTextBox1.Handle, 1081, 0, i)
    End Sub

    Public Function SetSelectionFont(ByVal face As String) As Boolean
        Dim sTRUCT_CHAR_FORMAT As STRUCT_CHAR_FORMAT = New STRUCT_CHAR_FORMAT
        sTRUCT_CHAR_FORMAT.cbSize = Marshal.SizeOf(sTRUCT_CHAR_FORMAT)
        sTRUCT_CHAR_FORMAT.dwMask = Convert.ToUInt32(536870912)
        sTRUCT_CHAR_FORMAT.szFaceName = New Char(32) {}
        face.CopyTo(0, sTRUCT_CHAR_FORMAT.szFaceName, 0, Math.Min(31, face.Length))
        Dim i As IntPtr = Marshal.AllocCoTaskMem(Marshal.SizeOf(sTRUCT_CHAR_FORMAT))
        Marshal.StructureToPtr(sTRUCT_CHAR_FORMAT, i, False)
        If SendMessage(RichTextBox1.Handle, 1092, SCF_SELECTION, i) = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function SetSelectionSize(ByVal size As Integer) As Boolean
        Dim sTRUCT_CHAR_FORMAT As STRUCT_CHAR_FORMAT = New STRUCT_CHAR_FORMAT
        sTRUCT_CHAR_FORMAT.cbSize = Marshal.SizeOf(sTRUCT_CHAR_FORMAT)
        sTRUCT_CHAR_FORMAT.dwMask = Convert.ToUInt32(2147483648)
        sTRUCT_CHAR_FORMAT.yHeight = size * 20
        Dim i As IntPtr = Marshal.AllocCoTaskMem(Marshal.SizeOf(sTRUCT_CHAR_FORMAT))
        Marshal.StructureToPtr(sTRUCT_CHAR_FORMAT, i, False)
        If SendMessage(RichTextBox1.Handle, 1092, SCF_SELECTION, i) = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function SetSelectionBold(ByVal bold As Boolean) As Boolean
        If bold Then
            Return SetSelectionStyle(1, 1)
        Else
            Return SetSelectionStyle(1, 0)
        End If
    End Function

    Public Function SetSelectionItalic(ByVal italic As Boolean) As Boolean
        If italic Then
            Return SetSelectionStyle(2, 2)
        Else
            Return SetSelectionStyle(2, 0)
        End If
    End Function

    Public Function SetSelectionUnderlined(ByVal underlined As Boolean) As Boolean
        If underlined Then
            Return SetSelectionStyle(4, 4)
        Else
            Return SetSelectionStyle(4, 0)
        End If
    End Function

    Private Function SetSelectionStyle(ByVal mask As Integer, ByVal effect As Integer) As Boolean
        Dim sTRUCT_CHAR_FORMAT As New STRUCT_CHAR_FORMAT
        sTRUCT_CHAR_FORMAT.cbSize = Marshal.SizeOf(sTRUCT_CHAR_FORMAT)
        sTRUCT_CHAR_FORMAT.dwMask = Convert.ToUInt32(mask)
        sTRUCT_CHAR_FORMAT.dwEffects = Convert.ToUInt32(effect)
        Dim i As IntPtr = Marshal.AllocCoTaskMem(Marshal.SizeOf(sTRUCT_CHAR_FORMAT))
        Marshal.StructureToPtr(sTRUCT_CHAR_FORMAT, i, False)

        If SendMessage(MyBase.Handle, 1092, SCF_SELECTION, i) = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim intPrintAreaWidth As Integer
        Dim intPrintAreaHeight As Integer
        Dim font As New Font("Microsoft Sans Serif", 10)
        Dim myPen As New Pen(Color.Blue, 2)
        Dim nWidth As Integer = PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize.Width
        Dim nHeight As Integer = PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize.Height
        With PrintDocument1.DefaultPageSettings
            intPrintAreaWidth = .PaperSize.Width - .Margins.Left - .Margins.Right
            intPrintAreaHeight = .PaperSize.Height - .Margins.Top
        End With
        m_nFirstCharOnPage = Me.FormatRange(False, _
                                      e, _
                                    m_nFirstCharOnPage, _
                                  RichTextBox1.Text.Length)


        '' e.Graphics.DrawLine(myPen, 0, intPrintAreaHeight + 30, PrintDocument1.DefaultPageSettings.PaperSize.Width, intPrintAreaHeight + 30)
        e.Graphics.DrawString("page: " & CStr(ipage), font, Brushes.Black, intPrintAreaWidth + 90, intPrintAreaHeight + 50)
        If (m_nFirstCharOnPage < RichTextBox1.Text.Length) Then
            ipage = ipage + 1
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If
    End Sub
#End Region

End Class
