﻿Imports System.IO
Public Class frmGenComb
    Dim nbcas, altitude As Integer
    Dim Type_cas(), Val_charge(), Mod_Expl() As Integer
    Dim ψ0(), ψ2() As Double
    Dim ELS, STR, EQU, Accid As Boolean
    Dim ind As Integer
    Private Sub frmGenComb_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ELS = False : STR = False : EQU = False : Accid = False
        nbcas = 1
        ReDim Type_cas(1), Val_charge(1)
        Type_cas(1) = 1 : Val_charge(1) = 1 'type de charge permanente et charge caractéristique
    End Sub

    Private Sub Tb2_Click(sender As System.Object, e As System.EventArgs) Handles Tb2.Enter
        Dim i As Integer
        Dim Liste_cas(nbcas - 1) As String
        CBcas.Items.Clear()
        Liste_cas(0) = "Cas n° 1"
        For i = 1 To nbcas - 1
            Liste_cas(i) = "Cas n° " & CStr(i + 1)
        Next
        RbtnPerma.Checked = True
        CBcas.Items.AddRange(Liste_cas)
        CBcas.Text = CBcas.Items(0).ToString
        ReDim ψ0(nbcas), ψ2(nbcas), Val_charge(nbcas), Type_cas(nbcas), Mod_Expl(nbcas)
        'initialisation
        For i = 1 To nbcas
            Type_cas(i) = 1  'toutes les charges sont des charges permanentes
            Val_charge(i) = 1 'toutes les charges sont des charges caractéristiques
            Mod_Expl(i) = 0 'Pas de catégories pour les charges permanentes
        Next
    End Sub
    Private Sub RbtnPerma_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPerma.CheckedChanged
        If RbtnPerma.Checked = True Then
            Type_cas(CInt(CBcas.SelectedIndex) + 1) = 1
        End If
    End Sub
    Private Sub RbtnExpl_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnExpl.CheckedChanged
        If RbtnExpl.Checked = True Then
            Type_cas(CInt(CBcas.SelectedIndex) + 1) = 2
            If RbtnAvecIndex.Checked = True Then
                'par hypothèse, toutes les charges suivantes sont de même type
                Dim i As Integer
                For i = (CInt(CBcas.SelectedIndex) + 1) + 1 To nbcas
                    Type_cas(i) = 2 : Mod_Expl(i) = 1
                Next
            End If
            CbPsi.Text = CbPsi.Items(0).ToString
            CbPsi.Focus()
        End If
    End Sub
    Private Sub CbPsi_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles CbPsi.SelectedIndexChanged
        Dim toto, titi As Integer
        toto = CInt(CBcas.SelectedIndex) + 1
        titi = CInt(CbPsi.SelectedIndex)
        Mod_Expl(toto) = titi + 1
    End Sub
    Private Sub RbtnSn_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnSn.CheckedChanged
        If RbtnSn.Checked = True Then
            Type_cas(CInt(CBcas.SelectedIndex) + 1) = 3
            If RbtnAvecIndex.Checked = True Then
                'par hypothèse, toutes les charges suivantes sont de même type
                Dim i As Integer
                For i = (CInt(CBcas.SelectedIndex) + 1) + 1 To nbcas
                    Type_cas(i) = 3
                Next
            End If
            RbtnNormal.Checked = True : TxtAlti.Focus()
        End If
    End Sub
    Private Sub TextAlti_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
        Call Gestion_Keypress(e, TxtAlti, True, True)
    End Sub
    Private Sub TxtAlti_TextChanged(sender As System.Object, e As System.EventArgs) Handles TxtAlti.TextChanged
        If TxtAlti.Text = "" Then TxtAlti.Text = "0"
        altitude = CInt(TxtAlti.Text)
    End Sub
    Private Sub RbtnNormal_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnNormal.CheckedChanged
        If RbtnNormal.Checked = True Then
            Val_charge(CInt(CBcas.SelectedIndex) + 1) = 1
        End If
    End Sub
    Private Sub RbtnAccid_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnAccid.CheckedChanged
        If RbtnAccid.Checked = True Then
            Val_charge(CInt(CBcas.SelectedIndex) + 1) = 2
        End If
    End Sub

    Private Sub RbtnVent_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnVent.CheckedChanged
        If RbtnVent.Checked = True Then
            Type_cas(CInt(CBcas.SelectedIndex) + 1) = 4
            If RbtnAvecIndex.Checked = True Then
                'par hypothèse, toutes les charges suivantes sont de même type
                Dim i As Integer
                For i = (CInt(CBcas.SelectedIndex) + 1) + 1 To nbcas
                    Type_cas(i) = 4
                Next
            End If
        End If
    End Sub

    Private Sub CBcas_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles CBcas.SelectedIndexChanged
        ind = CInt(CBcas.SelectedIndex) + 1
        Call Affichage()
    End Sub

    Private Sub TxtNbcas_TextChanged(sender As System.Object, e As System.EventArgs) Handles TxtNbcas.LostFocus
        nbcas = CInt(TxtNbcas.Text)
    End Sub

#Region "Gestion des coches ELU STR,ELU Accid, ELs, ..."

    Private Sub ChkbEluEQU_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbEluEQU.CheckedChanged
        If ChkbEluEQU.Checked = True Then EQU = True Else EQU = False
    End Sub

    Private Sub ChkbEluSTR_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbEluSTR.CheckedChanged
        If ChkbEluSTR.Checked = True Then STR = True Else STR = False
    End Sub

    Private Sub ChkbAccid_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbAccid.CheckedChanged
        If ChkbAccid.Checked = True Then Accid = True Else Accid = False
    End Sub

    Private Sub ChkbELS_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ChkbELS.CheckedChanged
        If ChkbELS.Checked = True Then ELS = True Else ELS = False
    End Sub
#End Region
    Private Sub Affichage()
        Select Case Type_cas(ind)
            Case 1 'Permanente
                'Pas de valeurs de  ψ0 ψ1  ψ2
                RbtnPerma.Checked = True
            Case 2 'Exploitation
                RbtnExpl.Checked = True
                CbPsi.Text = CbPsi.Items(Mod_Expl(ind) - 1).ToString
            Case 3 'Neige
                RbtnSn.Checked = True
                If Val_charge(ind) = 1 Then RbtnNormal.Checked = True Else RbtnAccid.Checked = True
                TxtAlti.Text = altitude.ToString
            Case 4 'Vent
                RbtnVent.Checked = True
        End Select
    End Sub
    Private Sub lecture()
        Dim i As Integer
        For i = 1 To nbcas
            Select Case Type_cas(i)
                Case 1 'Permanente
                    'Pas de valeurs de  ψ0 ψ1  ψ2
                Case 2 'Exploitation
                    Select Case Mod_Expl(i)
                        Case 1 'cat A
                            ψ0(i) = 0.7 : ψ2(i) = 0.3
                        Case 2 ' cat B
                            ψ0(i) = 0.7 : ψ2(i) = 0.3
                        Case 3 'cat C
                            ψ0(i) = 0.7 : ψ2(i) = 0.6
                        Case 4 ' cat D
                            ψ0(i) = 0.7 : ψ2(i) = 0.6
                        Case 5 'cat E
                            ψ0(i) = 1 : ψ2(i) = 0.8
                        Case 6 ' cat F
                            ψ0(i) = 0.7 : ψ2(i) = 0.6
                        Case 7 'cat G
                            ψ0(i) = 0.7 : ψ2(i) = 0.3
                        Case 8 ' cat H
                            ψ0(i) = 0 : ψ2(i) = 0
                    End Select
                Case 3 'Neige
                    If altitude > 1000 Then
                        ψ0(i) = 0.7 : ψ2(i) = 0.2
                    Else
                        ψ0(i) = 0.5 : ψ2(i) = 0
                    End If
                Case 4 'Vent
                    ψ0(i) = 0.6 : ψ2(i) = 0
            End Select
        Next
    End Sub

    Private Sub BtnAnnul_Click(sender As System.Object, e As System.EventArgs) Handles BtnAnnul.Click
        Me.Dispose()
        Me.Finalize()
    End Sub
    Private Sub BtnOK_Click(sender As System.Object, e As System.EventArgs) Handles BtnOK.Click
        Dim FileName As String
        Call lecture()
        OpenFileDialog1.Title = "Ouvrir le projet pour l'injection des combinaisons..."
        OpenFileDialog1.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        OpenFileDialog1.Filter = "Fichiers textes (*.txt)|*.txt|Fichiers textes (*.rtf)|*.rtf|Tous les fichiers (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()
        If OpenFileDialog1.FileName <> "" Then
            FileName = OpenFileDialog1.FileName
            Dim toto As String = FileName
            Call Injection_comb(FileName)
        End If
        Me.Close()
    End Sub
    Private Sub Injection_comb(ByVal FileName As String)
        Dim i, k, total_chaine As Integer
        Dim toto1(2000) As String
        Dim msg, titi(100) As String
        Dim myStreamReader As StreamReader
        Try
            i = 1
            myStreamReader = File.OpenText(FileName)
            toto1(i) = myStreamReader.ReadLine
            Do While toto1(i) <> ""
                i = i + 1
                toto1(i) = myStreamReader.ReadLine
                If toto1(i) <> "" Then
                    Call Lecture_chaine(toto1(i), titi, total_chaine)  'décomposition de la chaine 
                    Select Case Microsoft.VisualBasic.Left(titi(1), 3)
                        Case "com" 'paragraphe combinaisons
                            k = 1
                            Exit Do
                        Case "fin"
                            k = 2
                    End Select
                End If
            Loop
            myStreamReader.Close()
            Call Generateur_de_combinaisons_suivant_Eurocode(nbcas, Type_cas, STR, EQU, Accid, ELS, ψ0, ψ2, Val_charge, FileName, i - 1, toto1, i)
            
        Catch ex As Exception
            MsgBox("Problème de lecture du fichier de données pour la ligne:" + vbCrLf + _
                     "' " & toto1(i) & " '" & _
                          vbCrLf + "Exception: " + ex.Message, MsgBoxStyle.Critical, "Génération de combinaisons")
        Finally
            ' Close the object if it has been created.
            If Not myStreamReader Is Nothing Then myStreamReader.Close()
        End Try


    End Sub
    Private Sub Lecture_chaine(ByVal toto As String, ByRef titi() As String, ByRef j As Integer)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        'j = nbre total de chaine
        Dim blanc(100), i, position As Integer
        Dim tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        If titi(1) = "'" Or titi(1) = ";" Then Exit Sub 'cette chaine correspond à un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position = 0 Then position = InStr(1, toto, ";")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        'supprime tout caractère "=" dans la chaine et le remplace par un blanc " "
        position = InStr(1, toto, "=")
        Do While position <> 0
            Mid(toto, position) = " "
            toto = Trim(toto)
            position = InStr(1, toto, "=")
        Loop
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Private Sub BtnAfficher_Click(sender As System.Object, e As System.EventArgs) Handles BtnAfficher.Click
        Try
            'Dim frm1 As New frmEdit
            'frm1.Affichage_frmEdit("\combinaisons.txt")
            Dim tot(1) As String
            Dim inutil As Integer
            tot(1) = "Combinaisons"
            Call lecture()
            Call Generateur_de_combinaisons_suivant_Eurocode(nbcas, Type_cas, STR, EQU, Accid, ELS, ψ0, ψ2, Val_charge, "Combinaisons.txt", 1, tot, inutil)
            Dim startInfo As New ProcessStartInfo("notepad.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "C:\Users\fux\Documents\Visual Studio 2010\Structure\Structure\bin\Debug\Combinaisons.txt"
            Process.Start(startInfo)
        Catch ex As Exception
            MsgBox("Problème de lecture/écriture du fichier de génération." + vbCrLf + _
                        vbCrLf + "Exception: " + ex.Message, MsgBoxStyle.Critical, "Génération de combinaisons")
        End Try
    End Sub
End Class