﻿Imports System.Math
Imports System.IO
Public Class frmJarret
    Dim Liste_IPE() As String = {"IPE  80", "IPE 100", "IPE 120", "IPE 140", "IPE 160", "IPE 180", "IPE 200", "IPE 220", "IPE 240", "IPE 270", "IPE 300", _
                                   "IPE 330", "IPE 360", "IPE 400", "IPE 450", "IPE 500", "IPE 550", "IPE 600"}
    Dim Liste_HEA() As String = {"HEA  80", "HEA 100", "HEA 120", "HEA 140", "HEA 160", "HEA 180", "HEA 200", "HEA 220", "HEA 240", "HEA 260", "HEA 280", _
                                 "HEA 300", "HEA 320", "HEA 340", "HEA 360", "HEA 400", "HEA 450", "HEA 500", "HEA 550", "HEA 600", "HEA 650", "HEA 700", _
                                 "HEA 800", "HEA 900", "HEA 1000"}
    Dim ProfilPot, ProfilTrav As Integer

    Private Sub frmJarret_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        txtL1.Enabled = False : txtL2.Enabled = False : txtL3.Enabled = False : txtL4.Enabled = False
        txth1.Enabled = False : txth2.Enabled = False : txth3.Enabled = False
        txth1j.Enabled = False : txth2j.Enabled = False

    End Sub

    Private Sub BtnCalcul_Click(sender As System.Object, e As System.EventArgs) Handles BtnCalcul.Click
        Dim L1, L2, L3, L4, H1, H1j, H2, H2j, H3, pente As Double

        Call Lecture_Fichier(L1, L2, L3, L4, H1, H1j, H2, H2j, H3, pente)

    End Sub
    Private Sub Lecture_Fichier(ByRef L1 As Double, ByRef L2 As Double, ByRef L3 As Double, ByRef L4 As Double, ByRef H1 As Double, ByRef H1j As Double, ByRef H2 As Double, _
                                ByRef H2j As Double, ByRef H3 As Double, ByRef pente As Double)


        If RbtnL3.Checked = True Then L3 = CDbl(txtL3.Text)
        If RbtnL4.Checked = True Then L4 = CDbl(txtL4.Text)
        If Rbtnh1.Checked = True Then H1 = CDbl(txth1.Text)
        If Rbtnh2.Checked = True Then H2 = CDbl(txth2.Text)
        If Rbtnh3.Checked = True Then H3 = CDbl(txth3.Text)
        If Rbtnh1j.Checked = True Then H1j = CDbl(txth1j.Text)
        If Rbtnh2j.Checked = True Then H2j = CDbl(txth2j.Text)


    End Sub
    Private Sub Dimension(ByVal L1 As Double, ByVal L2 As Double, ByVal L3 As Double, ByVal L4 As Double, ByVal H1 As Double, ByVal H1j As Double, ByVal H2 As Double, _
                                ByVal H2j As Double, ByVal H3 As Double, ByVal pente As Double)
        Dim Profile As String
        Dim hjar, LongJar, hsousJar, hl, hlpot, L As Double
        Dim numPot, numTrav As Integer
        Profile = CbIH1.Text : Profile = Profile.Substring(4) : Profile = Profile.Trim(CChar(" "))
        numPot = CInt(Profile)
        Profile = CbIH2.Text : Profile = Profile.Substring(4) : Profile = Profile.Trim(CChar(" "))
        numTrav = CInt(Profile)
        pente = CDbl(txtPente.Text)
        pente = Atan(pente / 100) ' -> conversion en radian
        Call Lecture_Caracteristiques_Geometriques(ProfilTrav, numTrav, hl, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, True)
        ' L1
        If RbtnL1.Checked = True Then L1 = CDbl(txtL1.Text)
        If RbtnL2.Checked = True Then
            L2 = CDbl(txtL2.Text)
            L = (hl / 2) * Tan(pente)
            L1 = L2 - L
        End If
        If RbtnL4.Checked = True Then
            L4 = CDbl(txtL4.Text)
            L1 = L4 / Cos(pente)
        End If
        If RbtnL3.Checked = True Then
            L3 = CDbl(txtL3.Text)
            If Rbtnh2j.Checked = True Then
                H2j = CDbl(txth2j.Text)
                L1 = L3 - hl * Tan(pente) - H2j * Tan(pente)
            ElseIf Rbtnh1j.Checked = True Then
                H1j = CDbl(txth1j.Text)
                H2j = H1j * Cos(pente)
            Else
                MsgBox("h1j ou h2j doivent être renseigné pour le calcul de L1", MsgBoxStyle.Critical, "calcul cotes")
                Exit Sub
            End If
        End If
        ' H3
        If Rbtnh1.Checked = True Then
            H1 = CDbl(txth1.Text)
            If Rbtnh1j.Checked = True Then
                H1j = CDbl(txth1j.Text)
                H3 = H1 - hl / Sin(pente) - H1j
            ElseIf Rbtnh2j.Checked = True Then
                H2j = CDbl(txth2j.Text)
                H1j = H2j / Cos(pente)
            Else
                MsgBox("h1j ou h2j doivent être renseigné pour le calcul de L1", MsgBoxStyle.Critical, "calcul cotes")
                Exit Sub
            End If
        End If
        If Rbtnh2.Checked = True Then
            H2 = CDbl(txth2.Text)
            If Rbtnh1j.Checked = True Then
                H1j = CDbl(txth1j.Text)
                Call Lecture_Caracteristiques_Geometriques(ProfilPot, numPot, hlpot, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, True)
                H3 = H2 - ((hl / Cos(pente)) - (Tan(pente) * hlpot / 2) - ((hl / 2) / Cos(pente))) - H1j
            ElseIf Rbtnh2j.Checked = True Then
                H2j = CDbl(txth2j.Text)
                H1j = H2j / Cos(pente)
                Call Lecture_Caracteristiques_Geometriques(ProfilPot, numPot, hlpot, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, True)
                H3 = H2 - ((hl / Cos(pente)) - (Tan(pente) * hlpot / 2) - ((hl / 2) / Cos(pente))) - H1j
            Else
                MsgBox("h1j ou h2j doivent être renseigné pour le calcul de L1", MsgBoxStyle.Critical, "calcul cotes")
                Exit Sub
            End If
        End If
        LongJar = L1
        hjar = H1j
        hsousJar = H3
        'Affichage Résultats
        TxtHjar.Text = hjar.ToString("#,##0.0")
        TxtHsousJar.Text = hsousJar.ToString("#,##0.0")
        txtLongJar.Text = LongJar.ToString("#,##0.0")
    End Sub
    Private Sub Lecture_Caracteristiques_Geometriques(ByVal mod_prof As Integer, ByVal Num_Prof As Integer, ByRef Hl As Double, ByRef Bl As Double, ByRef tw As Double, _
                                                     ByRef tf As Double, ByRef r As Double, ByRef A As Double, ByRef hw As Double, ByRef Iyy As Double, ByRef Wely As Double, _
                                                     ByRef Wply As Double, ByRef Avz As Double, ByRef iry As Double, ByRef Izz As Double, ByRef Welz As Double, ByRef Wplz As Double, _
                           ByRef Avy As Double, ByRef irz As Double, ByRef It As Double, ByRef Iw As Double, ByRef d As Double, _
                           ByRef Verif As Boolean)
        Dim i As Integer
        Dim msg As String
        Verif = True
        Select Case mod_prof
            Case 10 'IPN
                Dim myStreamReader As StreamReader
                myStreamReader = File.OpenText(IPN)
                Dim toto, titi(31) As String
                Try
                    Dim profil() As Integer = {80, 100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 380, 400, 450, 500, 550, 600}
                    Dim Ligne() As Integer = {5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25}
                    Dim i1, i2 As Integer
                    For i2 = 0 To UBound(profil)
                        If Num_Prof = profil(i2) Then i1 = Ligne(i2) : Exit For
                        If i2 = UBound(profil) Then
                            msg = "Lecture Caractéristique du profilé IPN:" & vbCrLf & _
                           " Le numéro du profilé IPN n'est pas valide."
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Caractéristiques géométriques")
                            Verif = False : Exit Sub
                        End If
                    Next
                    For i = 1 To i1 - 1 : toto = myStreamReader.ReadLine : Next 'on n'affecte aucune valeur sur les 5 premières lignes
                    toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                    A = CDbl(titi(10)) 'Aire en cm²
                    d = CDbl(titi(11)) 'hauteur âme droite non compris congé de raccordement, en mm
                    Hl = CDbl(titi(4)) 'hauteur profilé en mm
                    Bl = CDbl(titi(5)) 'largeur profilé en mm
                    tw = CDbl(titi(6)) 'épaisseur de l'âme en mm
                    tf = CDbl(titi(7)) 'épaisseur de la semelle en mm
                    r = CDbl(titi(8)) 'rayon du congé de raccordement en mm
                    Iyy = CDbl(titi(20)) 'Inertie par rapport à YY en cm4
                    Wely = CDbl(titi(21)) 'Module de résistance élastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wply = CDbl(titi(22)) 'Module de résistance plastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    iry = CDbl(titi(23)) 'rayon de giration par rapport à l'axe fort, en cm
                    ' Avz = CDbl(titi(24)) 'Aire Avz de cisaillement
                    Izz = CDbl(titi(25)) 'Inertie par rapport à ZZ en cm4
                    Welz = CDbl(titi(26)) 'Module de résistance élastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wplz = CDbl(titi(27)) 'Module de résistance plastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    irz = CDbl(titi(28)) 'rayon de giration par rapport à l'axe faible, en cm
                    It = CDbl(titi(30)) 'Inertie de torsion de Saint-Venant cm4
                    Iw = CDbl(titi(31)) 'Inertie de gauchissement
                    hw = Hl - 2 * tf 'hauteur âme y compris congé de raccordement, en mm
                Catch exc As Exception
                    ' Show the exception to the user.
                    MsgBox("Le fichier ne peut être ouvert ou lu." + vbCrLf + _
                        "SVP, verifiez que le nom du fichier est correct, " + _
                        "et que vouz avez la permission de lire ou d'écrire " + _
                        "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, MsgBoxStyle.Critical, "Module de lecture")
                    Verif = False
                Finally
                    If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
                End Try
            Case 1 'IPE
                Dim myStreamReader As StreamReader
                myStreamReader = File.OpenText(IPE)
                Dim toto, titi(31) As String
                Try
                    Dim profil() As Integer = {80, 100, 120, 140, 160, 180, 200, 220, 240, 270, 300, 330, 360, 400, 450, 500, 550, 600}
                    Dim Ligne() As Integer = {6, 8, 10, 12, 14, 16, 19, 22, 25, 28, 31, 34, 37, 40, 43, 46, 49, 52}
                    Dim i1, i2 As Integer
                    For i2 = 0 To UBound(profil)
                        If Num_Prof = profil(i2) Then i1 = Ligne(i2) : Exit For
                        If i2 = UBound(profil) Then
                            msg = "Lecture Caractéristique du profilé IPE:" & vbCrLf & _
                           " Le numéro du profilé IPE n'est pas valide."
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Caractéristiques géométriques")
                            Verif = False : Exit Sub
                        End If
                    Next
                    For i = 1 To i1 - 1 : toto = myStreamReader.ReadLine : Next 'on n'affecte aucune valeur sur les 5 premières lignes
                    toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                    A = CDbl(titi(9)) 'Aire en cm²
                    hw = CDbl(titi(10)) 'hauteur âme y compris congé de raccordement, en mm
                    d = CDbl(titi(11)) 'hauteur âme droite non compris congé de raccordement, en mm
                    Hl = CDbl(titi(4)) 'hauteur profilé en mm
                    Bl = CDbl(titi(5)) 'largeur profilé en mm
                    tw = CDbl(titi(6)) 'épaisseur de l'âme en mm
                    tf = CDbl(titi(7)) 'épaisseur de la semelle en mm
                    r = CDbl(titi(8)) 'rayon du congé de raccordement en mm
                    Iyy = CDbl(titi(20)) 'Inertie par rapport à YY en cm4
                    Wely = CDbl(titi(21)) 'Module de résistance élastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wply = CDbl(titi(22)) 'Module de résistance plastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    iry = CDbl(titi(23)) 'rayon de giration par rapport à l'axe fort, en cm
                    ' Avz = CDbl(titi(24)) 'Aire Avz de cisaillement
                    Izz = CDbl(titi(25)) 'Inertie par rapport à ZZ en cm4
                    Welz = CDbl(titi(26)) 'Module de résistance élastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wplz = CDbl(titi(27)) 'Module de résistance plastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    irz = CDbl(titi(28)) 'rayon de giration par rapport à l'axe faible, en cm
                    It = CDbl(titi(30)) 'Inertie de torsion de Saint-Venant cm4
                    Iw = CDbl(titi(31)) 'Inertie de gauchissement
                Catch exc As Exception
                    ' Show the exception to the user.
                    MsgBox("Le fichier ne peut être ouvert ou lu." + vbCrLf + _
                        "SVP, verifiez que le nom du fichier est correct, " + _
                        "et que vouz avez la permission de lire ou d'écrire " + _
                        "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, MsgBoxStyle.Critical, "Module de lecture")
                    Verif = False
                Finally
                    If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
                End Try
            Case 2 'HEA
                Dim myStreamReader As StreamReader
                myStreamReader = File.OpenText(HE_HL)
                Dim toto, titi(31) As String
                Try
                    Dim profil() As Integer = {100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 400, 450, 500, 550, 600, 650, 700, 1400, 900, 1000}
                    Dim Ligne() As Integer = {6, 10, 14, 18, 22, 26, 30, 34, 38, 42, 46, 50, 54, 58, 62, 66, 70, 74, 78, 84, 90, 96, 102, 109}
                    Dim i1, i2 As Integer
                    For i2 = 0 To UBound(profil)
                        If Num_Prof = profil(i2) Then i1 = Ligne(i2) : Exit For
                        If i2 = UBound(profil) Then
                            msg = "Lecture Caractéristique du profilé HEA:" & vbCrLf & _
                           " Le numéro du profilé HEA n'est pas valide."
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Caractéristiques géométriques")
                            Verif = False : Exit Sub
                        End If
                    Next
                    For i = 1 To i1 - 1 : toto = myStreamReader.ReadLine : Next 'on n'affecte aucune valeur sur les 5 premières lignes
                    toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                    A = CDbl(titi(10)) 'Aire en cm²
                    hw = CDbl(titi(11)) 'hauteur âme y compris congé de raccordement, en mm
                    d = CDbl(titi(12)) 'hauteur âme droite non compris congé de raccordement, en mm
                    Hl = CDbl(titi(5)) 'hauteur profilé en mm
                    Bl = CDbl(titi(6)) 'largeur profilé en mm
                    tw = CDbl(titi(7)) 'épaisseur de l'âme en mm
                    tf = CDbl(titi(8)) 'épaisseur de la semelle en mm
                    r = CDbl(titi(9)) 'rayon du congé de raccordement en mm
                    Iyy = CDbl(titi(22)) 'Inertie par rapport à YY en cm4
                    Wely = CDbl(titi(23)) 'Module de résistance élastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wply = CDbl(titi(24)) 'Module de résistance plastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    iry = CDbl(titi(25)) 'rayon de giration par rapport à l'axe fort, en cm
                    ' Avz = CDbl(titi(26)) 'Aire Avz de cisaillement
                    Izz = CDbl(titi(27)) 'Inertie par rapport à ZZ en cm4
                    Welz = CDbl(titi(28)) 'Module de résistance élastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wplz = CDbl(titi(29)) 'Module de résistance plastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    irz = CDbl(titi(30)) 'rayon de giration par rapport à l'axe faible, en cm
                    It = CDbl(titi(32)) 'Inertie de torsion de Saint-Venant cm4
                    Iw = CDbl(titi(33)) 'Inertie de gauchissement
                Catch exc As Exception
                    ' Show the exception to the user.
                    MsgBox("Le fichier ne peut être ouvert ou lu." + vbCrLf + _
                        "SVP, verifiez que le nom du fichier est correct, " + _
                        "et que vouz avez la permission de lire ou d'écrire " + _
                        "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, MsgBoxStyle.Critical, "Module de lecture")
                    Verif = False
                Finally
                    If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
                End Try
            Case 4 'HEB
                Dim myStreamReader As StreamReader
                myStreamReader = File.OpenText(HE_HL)
                Dim toto, titi(31) As String
                Try
                    Dim profil() As Integer = {100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 400, 450, 500, 550, 600, 650, 700, 1400, 900, 1000}
                    Dim Ligne() As Integer = {7, 11, 15, 19, 23, 27, 31, 35, 39, 43, 47, 51, 55, 59, 63, 67, 71, 75, 79, 85, 91, 97, 103, 110}
                    Dim i1, i2 As Integer
                    For i2 = 0 To UBound(profil)
                        If Num_Prof = profil(i2) Then i1 = Ligne(i2) : Exit For
                        If i2 = UBound(profil) Then
                            msg = "Lecture Caractéristique du profilé HEB:" & vbCrLf & _
                           " Le numéro du profilé HEB n'est pas valide."
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Caractéristiques géométriques")
                            Verif = False : Exit Sub
                        End If
                    Next
                    For i = 1 To i1 - 1 : toto = myStreamReader.ReadLine : Next 'on n'affecte aucune valeur sur les 5 premières lignes
                    toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
                    A = CDbl(titi(10)) 'Aire en cm²
                    hw = CDbl(titi(11)) 'hauteur âme y compris congé de raccordement, en mm
                    d = CDbl(titi(12)) 'hauteur âme droite non compris congé de raccordement, en mm
                    Hl = CDbl(titi(5)) 'hauteur profilé en mm
                    Bl = CDbl(titi(6)) 'largeur profilé en mm
                    tw = CDbl(titi(7)) 'épaisseur de l'âme en mm
                    tf = CDbl(titi(8)) 'épaisseur de la semelle en mm
                    r = CDbl(titi(9)) 'rayon du congé de raccordement en mm
                    Iyy = CDbl(titi(22)) 'Inertie par rapport à YY en cm4
                    Wely = CDbl(titi(23)) 'Module de résistance élastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wply = CDbl(titi(24)) 'Module de résistance plastique selon l'axe fort - EN 1993-1-1 §6.3.2.1(3),en cm3
                    iry = CDbl(titi(25)) 'rayon de giration par rapport à l'axe fort, en cm
                    ' Avz = CDbl(titi(26)) 'Aire Avz de cisaillement
                    Izz = CDbl(titi(27)) 'Inertie par rapport à ZZ en cm4
                    Welz = CDbl(titi(28)) 'Module de résistance élastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    Wplz = CDbl(titi(29)) 'Module de résistance plastique selon l'axe faible - EN 1993-1-1 §6.3.2.1(3),en cm3
                    irz = CDbl(titi(30)) 'rayon de giration par rapport à l'axe faible, en cm
                    It = CDbl(titi(32)) 'Inertie de torsion de Saint-Venant cm4
                    Iw = CDbl(titi(33)) 'Inertie de gauchissement
                Catch exc As Exception
                    ' Show the exception to the user.
                    MsgBox("Le fichier ne peut être ouvert ou lu." + vbCrLf + _
                        "SVP, verifiez que le nom du fichier est correct, " + _
                        "et que vouz avez la permission de lire ou d'écrire " + _
                        "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, MsgBoxStyle.Critical, "Module de lecture")
                    Verif = False
                Finally
                    If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
                End Try
            Case Else
                msg = "Erreur d'identification"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Caractéristiques géométriques profilés métalliques")
                Verif = False
                Exit Sub
        End Select
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(45), i, j, position As Integer
        Dim tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
    End Sub

#Region "Gestion des Rbtn"
    Private Sub RbtnL1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnL1.CheckedChanged
        If RbtnL1.Checked = True Then
            txtL1.Enabled = True : txtL1.Focus()
        Else
            txtL1.Text = "" : txtL1.Enabled = False
        End If
    End Sub

    Private Sub RbtnL2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnL2.CheckedChanged
        If RbtnL2.Checked = True Then
            txtL2.Enabled = True : txtL2.Focus()
        Else
            txtL2.Text = "" : txtL2.Enabled = False
        End If
    End Sub

    Private Sub RbtnL3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnL3.CheckedChanged
        If RbtnL3.Checked = True Then
            txtL3.Enabled = True : txtL3.Focus()
        Else
            txtL3.Text = "" : txtL3.Enabled = False
        End If
    End Sub

    Private Sub RbtnL4_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnL4.CheckedChanged
        If RbtnL4.Checked = True Then
            txtL4.Enabled = True : txtL4.Focus()
        Else
            txtL4.Text = "" : txtL4.Enabled = False
        End If
    End Sub

    Private Sub Rbtnh1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtnh1.CheckedChanged
        If Rbtnh1.Checked = True Then
            txth1.Enabled = True : txth1.Focus()
        Else
            txth1.Text = "" : txth1.Enabled = False
        End If
    End Sub

    Private Sub Rbtnh2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtnh2.CheckedChanged
        If Rbtnh2.Checked = True Then
            txth2.Enabled = True : txth2.Focus()
        Else
            txth2.Text = "" : txth2.Enabled = False
        End If
    End Sub

    Private Sub Rbtnh3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtnh3.CheckedChanged
        If Rbtnh3.Checked = True Then
            txth3.Enabled = True : txth3.Focus()
        Else
            txth3.Text = "" : txth3.Enabled = False
        End If
    End Sub

    Private Sub Rbtnh1j_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtnh1j.CheckedChanged
        If Rbtnh1j.Checked = True Then
            txth1j.Enabled = True : txth1j.Focus()
        Else
            txth1j.Text = "" : txth1j.Enabled = False
        End If
    End Sub

    Private Sub Rbtnh2j_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtnh2j.CheckedChanged
        If Rbtnh2j.Checked = True Then
            txth2j.Enabled = True : txth2j.Focus()
        Else
            txth2j.Text = "" : txth2j.Enabled = False
        End If
    End Sub
#End Region

    Private Sub CBPoteau_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles CBPoteau.SelectedIndexChanged
        ProfilPot = CInt(CBPoteau.SelectedIndex) + 1 'IPE=1,HEA=2, PRS=3
        CbIH1.Items.Clear()
        Select Case ProfilPot
            Case 1 'IPE
                CbIH1.Items.AddRange(Liste_IPE)
            Case 2 'HEA
                CbIH1.Items.AddRange(Liste_HEA)
        End Select
        CbIH1.Text = CbIH1.Items(0).ToString
    End Sub

    Private Sub CbTrav_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles CbTrav.SelectedIndexChanged
        ProfilTrav = CInt(CbTrav.SelectedIndex) + 1 'IPE=1,HEA=2, PRS=3
        CbIH2.Items.Clear()
        Select Case ProfilTrav
            Case 1 'IPE
                CbIH2.Items.AddRange(Liste_IPE)
            Case 2 'HEA
                CbIH2.Items.AddRange(Liste_HEA)
        End Select
        CbIH2.Text = CbIH2.Items(0).ToString
    End Sub

    Private Sub BtnAide_Click(sender As System.Object, e As System.EventArgs) Handles BtnAide.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 38
        frm1.Show()
    End Sub

    Private Sub BtnMiseaZero_Click(sender As System.Object, e As System.EventArgs) Handles BtnMiseaZero.Click
        txtL1.Enabled = False : txtL2.Enabled = False : txtL3.Enabled = False : txtL4.Enabled = False
        txth1.Enabled = False : txth2.Enabled = False : txth3.Enabled = False
        txth1j.Enabled = False : txth2j.Enabled = False
        txtL1.Text = "" : txtL2.Text = "" : txtL3.Text = "" : txtL4.Text = ""
        txth1.Text = "" : txth2.Text = "" : txth3.Text = ""
        txth1j.Text = "" : txth2j.Text = ""
        RbtnL1.Checked = False : RbtnL2.Checked = False : RbtnL3.Checked = False : RbtnL4.Checked = False
        Rbtnh1.Checked = False : Rbtnh2.Checked = False : Rbtnh3.Checked = False
        Rbtnh1j.Checked = False : Rbtnh2j.Checked = False
    End Sub
End Class